/**********************************************************************
 *<
	FILE: mods.h

	DESCRIPTION:

	CREATED BY: Rolf Berteig (based on prim.h)

	HISTORY:

 *>	Copyright (c) 1994, All Rights Reserved.
 **********************************************************************/

#ifndef __SCATTERINKMODS__H
#define __SCATTERINKMODS__H

#include "Max.h"
#include "modsres.h"
#include "iparamm2.h"
#include "modstack.h"
#include "icurvctl.h"
#include "meshadj.h"
#include "macrorec.h"
#include "SURF_API.h"
#include "polyobj.h"
#include "..\include\ipaintmod.h"
#include "..\include\iink.h"


TCHAR *GetString(int id);





enum { customink_params};

enum {	customink_node,
		customink_match
		
	}; 


#define RUBBERSTAMPINK_CLASSID 0xDE285555, 0x8A52E333

class RubberStampInkClass : public IInkClass, public ResourceMakerCallback
	{
public:


	RubberStampInkClass();
	~RubberStampInkClass();
	const TCHAR *	ClassName() { return GetString(IDS_PW_RUBBERSTAMPINK); }
	void GetClassName(TSTR& s) {s = GetString(IDS_PW_RUBBERSTAMPINK);}  

	SClass_ID		SuperClassID() { return REF_TARGET_CLASS_ID; }
	Class_ID ClassID() { return Class_ID(RUBBERSTAMPINK_CLASSID);}      
    void BeginEditParams(IObjParam  *ip, ULONG flags,Animatable *prev);
    void EndEditParams(IObjParam *ip,ULONG flags,Animatable *next);
	void* GetInterface(ULONG id)
		{
		if(id == I_RESMAKER_INTERFACE)
			return (void *) (ResourceMakerCallback *) this;
		else if(id == I_INK)
			return (IInkClass *) this;
		else
			return (void *) NULL;
		}

    // From Animatable
    void DeleteThis() { 
					delete this; 
					}


	void StartStroke( );

	BOOL ApplyInk(Point3 p,  Point3 surfaceNorm, Point3 bary, DWORD faceIndex,
				  Mesh *msh,
							float str, float radius, float pressure, 
							ICurve *pCurve,
							Tab<Point3> &basePoints,	Tab<Point3> &deltaPoints,Tab<Point3> &tempDeltaPoints,
							Matrix3 toWorld,
							BOOL additive,
							BOOL &updateStack);

	void EndStroke();

	void CancelStroke();



	BOOL matchVerts;
	INode *node;

	};




class RubberStampInkClassDesc:public ClassDesc2 {
	public:
	int 			IsPublic() { return 0; }
	void *			Create(BOOL loading = FALSE) { return new RubberStampInkClass; }
	const TCHAR *	ClassName() { return GetString(IDS_PW_RUBBERSTAMPINK); }
	SClass_ID		SuperClassID() { return REF_TARGET_CLASS_ID; }
											   
	Class_ID		ClassID() { return Class_ID(RUBBERSTAMPINK_CLASSID); }
	const TCHAR* 	Category() { return GetString(IDS_PW_GIZMOCATEGORY);}

// JBW: new descriptor data accessors added.  Note that the 
//      internal name is hardwired since it must not be localized.
	const TCHAR*	InternalName() { return _T("rubberStampInk"); }	// returns fixed parsable name (scripter-visible name)
	HINSTANCE		HInstance() { return hInstance; }			// returns owning module handle



	};

static RubberStampInkClassDesc scatterInkDesc;
extern ClassDesc* GetRubberStampInkDesc() {return &scatterInkDesc;}


#endif

