/**********************************************************************
 *<
	FILE: mods.h

	DESCRIPTION:

	CREATED BY: Rolf Berteig (based on prim.h)

	HISTORY:

 *>	Copyright (c) 1994, All Rights Reserved.
 **********************************************************************/

#ifndef __SCATTERINKMODS__H
#define __SCATTERINKMODS__H

#include "Max.h"
#include "modsres.h"
#include "iparamm2.h"
#include "modstack.h"
#include "icurvctl.h"
#include "meshadj.h"
#include "macrorec.h"
#include "SURF_API.h"
#include "polyobj.h"
#include "..\include\ipaintmod.h"
#include "..\include\iink.h"


TCHAR *GetString(int id);





enum { customink_params};

enum {	customink_node,
		customink_scale,
		customink_alignz, customink_alignmotion,
		customink_scaletype,
		customink_graph,
		customink_instance,
		customink_skip,
		customink_offset,
		customink_x,customink_y,customink_z
		
	}; 


#define SCATTERINK_CLASSID 0xDE28A457, 0x8A52E200

class ScatterInkClass : public IInkClass, public ResourceMakerCallback
	{
public:


	ScatterInkClass();
	~ScatterInkClass();
	const TCHAR *	ClassName() { return GetString(IDS_PW_SCATTERINK); }
	void GetClassName(TSTR& s) {s = GetString(IDS_PW_SCATTERINK);}  

	SClass_ID		SuperClassID() { return REF_TARGET_CLASS_ID; }
	Class_ID ClassID() { return Class_ID(SCATTERINK_CLASSID);}      
    void BeginEditParams(IObjParam  *ip, ULONG flags,Animatable *prev);
    void EndEditParams(IObjParam *ip,ULONG flags,Animatable *next);
	void* GetInterface(ULONG id)
		{
		if(id == I_RESMAKER_INTERFACE)
			return (void *) (ResourceMakerCallback *) this;
		else if(id == I_INK)
			return (IInkClass *) this;
		else
			return (void *) NULL;
		}

    // From Animatable
    void DeleteThis() { 
					delete this; 
					}


	void StartStroke( );

	BOOL ApplyInk(Point3 p,  Point3 surfaceNorm, Point3 bary, DWORD faceIndex,
				  Mesh *msh,
							float str, float radius, float pressure, 
							ICurve *pCurve,
							Tab<Point3> &basePoints,	Tab<Point3> &deltaPoints,Tab<Point3> &tempDeltaPoints,
							Matrix3 toWorld,
							BOOL additive,
							BOOL &updateStack);

	void EndStroke();

	void CancelStroke();



	float scale;
	INode *node;
	BOOL alignZ;
	BOOL alignMotion;

	int scaleType;

	BOOL instance;
	int skip;
	float offset;
	int skipCount;

	ICurveCtl *graph;
	ICurve *curve;
	Tab<INode*> nodeList;
	BOOL scaleX, scaleY, scaleZ;
	Point3 lastPoint, lastScale;

	};

class ScatterInkParamsMapDlgProc : public ParamMap2UserDlgProc {
	public:
		ScatterInkClass *ink;		
		ScatterInkParamsMapDlgProc(ScatterInkClass *m) {ink = m;}		
		BOOL DlgProc(TimeValue t,IParamMap2 *map,HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam);		
		void DeleteThis() {
				delete this;
				}
	};



class ScatterInkClassDesc:public ClassDesc2 {
	public:
	int 			IsPublic() { return 0; }
	void *			Create(BOOL loading = FALSE) { return new ScatterInkClass; }
	const TCHAR *	ClassName() { return GetString(IDS_PW_SCATTERINK); }
	SClass_ID		SuperClassID() { return REF_TARGET_CLASS_ID; }
											   
	Class_ID		ClassID() { return Class_ID(SCATTERINK_CLASSID); }
	const TCHAR* 	Category() { return GetString(IDS_PW_GIZMOCATEGORY);}

// JBW: new descriptor data accessors added.  Note that the 
//      internal name is hardwired since it must not be localized.
	const TCHAR*	InternalName() { return _T("scatterInk"); }	// returns fixed parsable name (scripter-visible name)
	HINSTANCE		HInstance() { return hInstance; }			// returns owning module handle



	};

static ScatterInkClassDesc scatterInkDesc;
extern ClassDesc* GetScatterInkDesc() {return &scatterInkDesc;}


#endif

