
#include "mods.h"
#include "shape.h"
#include "spline3d.h"
#include "splshape.h"
#include "linshape.h"


// per instance gizmo block
static ParamBlockDesc2 customink_scatter_blk ( customink_params, _T("scatterInk"),  0, &scatterInkDesc, P_AUTO_CONSTRUCT + P_AUTO_UI, 0, 
	//rollout
	IDD_SCATTERINK, IDS_PW_SCATTERINK, 0, 0, NULL,
	// params
	customink_node, 	_T("node"),		TYPE_INODE, 		0,				IDS_PW_NODE,
		p_ui, 			TYPE_PICKNODEBUTTON, 	IDC_PICKNODE, 
		end, 

	customink_scale,  _T("scale"), TYPE_FLOAT, 	0, 	IDS_SCALE, 
		p_default, 		1.0f,	
		p_range, 		-999999.f,999999.f, 
		p_ui,  		TYPE_SPINNER, EDITTYPE_FLOAT, IDC_SCALE,IDC_SCALE_SPIN,  0.1f,
		end, 

	customink_alignz,  _T("alignz"), TYPE_INT, 	0, 	IDS_ALIGNZ, 
		p_default, 		TRUE,	
		p_ui,  		TYPE_SINGLECHEKBOX, IDC_ALIGNZ, 
		p_enable_ctrls,	1, customink_alignmotion,
		end, 

	customink_alignmotion,  _T("alignMotion"), TYPE_INT, 	0, 	IDS_ALIGNMOTION, 
		p_default, 		FALSE,	
		p_ui,  		TYPE_SINGLECHEKBOX, IDC_ALIGNMOTION, 
		end, 

	customink_scaletype,  _T("scaleType"), TYPE_INT, 	0, 	IDS_SCALETYPE, 
		p_default, 		0,	
		p_range, 		0, 2, 
		p_ui, 			TYPE_RADIO, 	3, IDC_RADIO1, IDC_RADIO2, IDC_RADIO3,
		end,

	customink_graph,  _T("graph"),	TYPE_REFTARG, 	P_SUBANIM, 	IDS_PW_GRAPH, 
		end,   

	customink_instance,  _T("instance"), TYPE_INT, 	0, 	IDS_INSTANCE, 
		p_default, 		TRUE,	
		p_ui,  		TYPE_SINGLECHEKBOX, IDC_INSTANCE, 
		end, 

	customink_skip,		_T("skip"), TYPE_INT, 	0, 	IDS_SKIP, 
		p_default, 		20,	
		p_range, 		1,10000, 
		p_ui,  		TYPE_SPINNER, EDITTYPE_INT, IDC_SKIP,IDC_SKIP_SPIN,  1.0f,
		end,

	customink_offset,		_T("offset"), TYPE_FLOAT, 	0, 	IDS_OFFSET, 
		p_default, 		0.0f,	
		p_range, 		-99999.0f,99999.0f, 
		p_ui,  		TYPE_SPINNER, EDITTYPE_FLOAT, IDC_OFFSET,IDC_OFFSET_SPIN,  1.0f,
		end,

	customink_x,  _T("scaleX"), TYPE_INT, 	0, 	IDS_SCALEX, 
		p_default, 		TRUE,	
		p_ui,  		TYPE_SINGLECHEKBOX, IDC_X, 
		end, 

	customink_y,  _T("scaleY"), TYPE_INT, 	0, 	IDS_SCALEY, 
		p_default, 		TRUE,	
		p_ui,  		TYPE_SINGLECHEKBOX, IDC_Y, 
		end, 

	customink_z,  _T("scaleZ"), TYPE_INT, 	0, 	IDS_SCALEZ, 
		p_default, 		TRUE,	
		p_ui,  		TYPE_SINGLECHEKBOX, IDC_Z, 
		end, 



	end
	);


BOOL ScatterInkParamsMapDlgProc::DlgProc(
		TimeValue t,IParamMap2 *map,HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam)
			
	{


	switch (msg) {
		case WM_INITDIALOG:
			{
			ReferenceTarget *ref;
			ink->pblock->GetValue(customink_graph,0,(ReferenceTarget *)ref,FOREVER);
			ink->graph = (ICurveCtl *)ref;
			if (ink->graph)
				{
				ink->graph->SetCustomParentWnd(GetDlgItem(hWnd, IDC_GRAPH));
				ink->graph->SetMessageSink(hWnd);
				}
			break;
			}
		case WM_COMMAND:
			{
			switch (LOWORD(wParam)) 
				{


				case IDC_GRAPH:
					{
					if (ink->graph)
						{
						ink->graph->SetCCFlags(CC_ASPOPUP|CC_DRAWBG|CC_DRAWSCROLLBARS|CC_AUTOSCROLL|CC_DRAWUTOOLBAR|
						  CC_DRAWRULER|CC_DRAWGRID|CC_DRAWLTOOLBAR|CC_SHOW_CURRENTXVAL|CC_ALL_RCMENU|CC_SINGLESELECT|CC_NOFILTERBUTTONS);
						if (ink->graph->IsActive())
							ink->graph->SetActive(FALSE);
						else 
							{
							ink->graph->SetActive(TRUE);
							ink->graph->ZoomExtents();
							}

						}

					break;
					}
				}
			break;
			}



		}
	return FALSE;
	}



ScatterInkClass::ScatterInkClass()
	{
	scatterInkDesc.MakeAutoParamBlocks(this);

	
	
	graph = (ICurveCtl *) CreateInstance(REF_MAKER_CLASS_ID,CURVE_CONTROL_CLASS_ID);

	graph->SetXRange(0,1.0f);
	graph->SetYRange(0.0f,1.0f);

	graph->RegisterResourceMaker((ReferenceMaker *)this);
	graph->SetNumCurves(1);
	

	graph->SetTitle(GetString(IDS_PW_GRAPH));
	
	BitArray ba;
	ba.SetSize(1);
	ba.SetAll();
	graph->SetDisplayMode(ba);
	graph->SetCCFlags(CC_ASPOPUP|CC_DRAWBG|CC_DRAWSCROLLBARS|CC_AUTOSCROLL|
					  CC_DRAWRULER|CC_DRAWGRID|
					  CC_RCMENU_MOVE_XY|CC_RCMENU_MOVE_X|CC_RCMENU_MOVE_Y|
					  CC_RCMENU_SCALE|CC_RCMENU_INSERT_CORNER | CC_RCMENU_INSERT_BEZIER|
					CC_RCMENU_DELETE | CC_SHOW_CURRENTXVAL	
					);	

	ICurve *pCurve = NULL;
	
	pCurve = graph->GetControlCurve(0);

	CurvePoint pt;

	pt.flags = CURVEP_CORNER | CURVEP_BEZIER | CURVEP_ENDPOINT;
	pt.out.x = 0.33f;
	pt.out.y = 0.0f;
	pt.in.x = -0.33f;
	pt.in.y = 0.0f;

	pt.p.x = 0.0f;			
	pt.p.y = 0.0f;			
	pCurve->SetPoint(0,0,&pt);
		
	pt.p.x = 1.0f;			
	pt.p.y = 1.0f;			
	pt.in.x = -.33f;
	pt.in.y = 0.0f;
	pt.out.x = .33f;
	pt.out.y = 0.0f;

	pCurve->SetPoint(0,1,&pt);

	pblock->SetValue(customink_graph,0,(ReferenceTarget*)graph);

	
	}
ScatterInkClass::~ScatterInkClass()
	{
	DeleteAllRefsFromMe();
	}

void ScatterInkClass::BeginEditParams(IObjParam  *ip, ULONG flags,Animatable *prev)
	{
	scatterInkDesc.BeginEditParams(ip, this, flags, prev);
	customink_scatter_blk.SetUserDlgProc(new ScatterInkParamsMapDlgProc(this));

	}
void ScatterInkClass::EndEditParams(IObjParam *ip,ULONG flags,Animatable *next)
	{
	scatterInkDesc.EndEditParams(ip, this, flags, next);
	if (graph->IsActive())
		graph->SetActive(FALSE);
	}


void ScatterInkClass::StartStroke( )
	{
	Interval iv;

	pblock->GetValue(customink_node,0,node,iv);
	pblock->GetValue(customink_scale,0,scale,iv);

	pblock->GetValue(customink_alignz,0,alignZ,iv);
	pblock->GetValue(customink_alignmotion,0,alignMotion,iv);
	pblock->GetValue(customink_scaletype,0,scaleType,iv);
	
	curve = graph->GetControlCurve(0);

	pblock->GetValue(customink_offset,0,offset,iv);
	pblock->GetValue(customink_instance,0,instance,iv);
	pblock->GetValue(customink_skip,0,skip,iv);

	pblock->GetValue(customink_x,0,scaleX,iv);
	pblock->GetValue(customink_y,0,scaleY,iv);
	pblock->GetValue(customink_z,0,scaleZ,iv);

	skipCount = 0;

	if (skip < 1) skip = 1;

	nodeList.ZeroCount();

	curve = graph->GetControlCurve(0);

	theHold.Begin();

	}

BOOL ScatterInkClass::ApplyInk(Point3 p,  Point3 surfaceNorm, Point3 bary, DWORD faceIndex,
							Mesh *msh,
							float str, float radius, float pressure, 
							ICurve *pCurve,
							Tab<Point3> &basePoints,	Tab<Point3> &deltaPoints,Tab<Point3> &tempDeltaPoints,
							Matrix3 toWorld, 
							BOOL additive,
							BOOL &updateStack)
	{
	updateStack = FALSE;
	

	p += Normalize(surfaceNorm) * offset;

	BOOL skipNode = FALSE;
	if (((skipCount%skip)!=0) || (node == NULL)) 
		{
		skipNode = TRUE;
		}
	skipCount++;

	Matrix3 tm(1);
	
	if (alignZ)
		{
		Point3 vec = VectorTransform(toWorld,Normalize(surfaceNorm));
		MatrixFromNormal(vec, tm);
		}
	if (alignMotion)
		{
		}
//apply scale
	Point3 scaleVec(1.0f,1.0f,1.0f);

	if (scaleType == 0)
		{
		scaleVec = scaleVec * scale;
		}
	else if (scaleType == 1)
		{
		scaleVec = scaleVec ;
		}
	else if (scaleType == 2)
		{
		scaleVec = scaleVec * scale * pressure;
		}

	if (!scaleX) scaleVec.x = 1.0f;
	if (!scaleY) scaleVec.y = 1.0f;
	if (!scaleZ) scaleVec.z = 1.0f;

	
	Point3 tp = p*toWorld;
	
	tm.SetTrans(tp);
	
	Point3 ax,ay,az;
	ax = tm.GetRow(0) * scaleVec.x;
	ay = tm.GetRow(1) * scaleVec.y;
	az = tm.GetRow(2) * scaleVec.z;

	tm.SetRow(0,ax);
	tm.SetRow(1,ay);
	tm.SetRow(2,az);

	int nodeCount = nodeList.Count();
	if ((nodeCount >0) && (alignMotion))
		{
		Point3 xVec,yVec,zVec;
		
		INode *lastNode = nodeList[nodeCount-1];
		Matrix3 lastTm = lastNode->GetNodeTM(GetCOREInterface()->GetTime());
		zVec = Normalize(lastTm.GetRow(2));
		Point3 vec = Normalize(lastPoint - tp);
		yVec = Normalize(CrossProd(zVec,vec)) *lastScale.y;
		xVec = Normalize(CrossProd(yVec,zVec)) *lastScale.x;
		lastTm.SetRow(0,xVec);
		lastTm.SetRow(1,yVec);
		lastNode->SetNodeTM(GetCOREInterface()->GetTime(),lastTm);

		}

	if (!skipNode)
		{
		Object *obj = NULL;
		if (instance)
			obj = (Object*) node->GetObjectRef();
		else obj = (Object*) node->GetObjectRef()->Clone();

		INode *tnode = GetCOREInterface()->CreateObjectNode(obj);
	
		TSTR name(_T("PaintScatter"));
		GetCOREInterface()->MakeNameUnique(name);
		tnode->SetName(name);
		tnode->SetNodeTM(GetCOREInterface()->GetTime(),tm);

		tnode->SetObjOffsetPos(node->GetObjOffsetPos());
		tnode->SetObjOffsetRot(node->GetObjOffsetRot());
		tnode->SetObjOffsetScale(node->GetObjOffsetScale());


		nodeList.Append(1,&tnode);
		lastPoint = tp;
		lastScale = scaleVec;
		
		}

	

	return skipNode;

	}

void ScatterInkClass::EndStroke()
	{
//go back and scale created nodes
	if (scaleType == 1)
		{
		for (int i =0; i < nodeList.Count(); i++)
			{
			Point3 scaleVec(1.0f,1.0f,1.0f);

			float amount = 1.0f;
			float per = 0.0f;
			if (nodeList.Count() > 1)
				per = (float) i/(float)(nodeList.Count()-1);
			amount =  curve->GetValue(0, per);

			scaleVec *= (scale*amount);

			if (!scaleX) scaleVec.x = 1.0f;
			if (!scaleY) scaleVec.y = 1.0f;
			if (!scaleZ) scaleVec.z = 1.0f;

			Point3 ax,ay,az;
			Matrix3 tm;

			tm = nodeList[i]->GetNodeTM(GetCOREInterface()->GetTime());
			ax = tm.GetRow(0) * scaleVec.x;
			ay = tm.GetRow(1) * scaleVec.y;
			az = tm.GetRow(2) * scaleVec.z;

			tm.SetRow(0,ax);
			tm.SetRow(1,ay);
			tm.SetRow(2,az);

			nodeList[i]->SetNodeTM(GetCOREInterface()->GetTime(),tm);


			}
		}

	theHold.Accept(TSTR(_T("Create Scatter")));
	}

void ScatterInkClass::CancelStroke()
	{
	theHold.Cancel();
	}


