/**********************************************************************
 *<
	FILE: mods.h

	DESCRIPTION:

	CREATED BY: Rolf Berteig (based on prim.h)

	HISTORY:

 *>	Copyright (c) 1994, All Rights Reserved.
 **********************************************************************/

#ifndef __SPLMODS__H
#define __SPLMODS__H

#include "Max.h"
#include "modsres.h"
#include "iparamm2.h"
#include "modstack.h"
#include "icurvctl.h"
#include "meshadj.h"
#include "macrorec.h"
#include "SURF_API.h"
#include "polyobj.h"
#include "..\include\ipaintmod.h"
#include "..\include\iink.h"


TCHAR *GetString(int id);





enum { customink_params};

enum { customink_offset,customink_size, customink_sides,
		customink_renderable,customink_mapping,customink_display,
		customink_steps,
		customink_offsettype,
		customink_graph,
		customink_uselength,
		customink_length,
		customink_uselimit,
		customink_limit,
	}; 


#define SPLINEINK_CLASSID 0xDE28A346, 0x8A52E2Ac

class SplineInkClass : public IInkClass, public ResourceMakerCallback
	{
public:


	SplineInkClass();
	~SplineInkClass();
	const TCHAR *	ClassName() { return GetString(IDS_PW_SPLINEINK); }
	void GetClassName(TSTR& s) {s = GetString(IDS_PW_SPLINEINK);}  

	SClass_ID		SuperClassID() { return REF_TARGET_CLASS_ID; }
	Class_ID ClassID() { return Class_ID(SPLINEINK_CLASSID);}      
    void BeginEditParams(IObjParam  *ip, ULONG flags,Animatable *prev);
    void EndEditParams(IObjParam *ip,ULONG flags,Animatable *next);
	void* GetInterface(ULONG id)
		{
		if(id == I_RESMAKER_INTERFACE)
			return (void *) (ResourceMakerCallback *) this;
		else if(id == I_INK)
			return (IInkClass *) this;
		else
			return (void *) NULL;
		}

    // From Animatable
    void DeleteThis() { 
					delete this; 
					}


	void StartStroke( );

	BOOL ApplyInk(Point3 p,  Point3 surfaceNorm, Point3 bary, DWORD faceIndex,
				  Mesh *msh,
							float str, float radius, float pressure, 
							ICurve *pCurve,
							Tab<Point3> &basePoints,	Tab<Point3> &deltaPoints,Tab<Point3> &tempDeltaPoints,
							Matrix3 toWorld,
							BOOL additive,
							BOOL &updateStack);

	void EndStroke();

	void CancelStroke();


	BOOL createMatrix;
	Tab<Point3> pointList;
	Tab<Point3> normalList;
	Tab<float> pressureList;
	Matrix3 toLocalTm;

	float offset;
	float radius;
	int sides;

	BOOL renderable, mapping, display;
	int steps;

	int offsetType;

	BOOL useLength;
	float length;

	BOOL useLimit;
	int limit;

	ICurveCtl *graph;
	ICurve *curve;

	};

class SplineInkParamsMapDlgProc : public ParamMap2UserDlgProc {
	public:
		SplineInkClass *ink;		
		SplineInkParamsMapDlgProc(SplineInkClass *m) {ink = m;}		
		BOOL DlgProc(TimeValue t,IParamMap2 *map,HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam);		
		void DeleteThis() {
				delete this;
				}
	};



class SplineInkClassDesc:public ClassDesc2 {
	public:
	int 			IsPublic() { return 0; }
	void *			Create(BOOL loading = FALSE) { return new SplineInkClass; }
	const TCHAR *	ClassName() { return GetString(IDS_PW_SPLINEINK); }
	SClass_ID		SuperClassID() { return REF_TARGET_CLASS_ID; }
											   
	Class_ID		ClassID() { return Class_ID(SPLINEINK_CLASSID); }
	const TCHAR* 	Category() { return GetString(IDS_PW_GIZMOCATEGORY);}

// JBW: new descriptor data accessors added.  Note that the 
//      internal name is hardwired since it must not be localized.
	const TCHAR*	InternalName() { return _T("splineInk"); }	// returns fixed parsable name (scripter-visible name)
	HINSTANCE		HInstance() { return hInstance; }			// returns owning module handle



	};

static SplineInkClassDesc splineInkDesc;
extern ClassDesc* GetSplineInkDesc() {return &splineInkDesc;}


#endif

