
#include "mods.h"
#include "shape.h"
#include "spline3d.h"
#include "splshape.h"
#include "linshape.h"


// per instance gizmo block
static ParamBlockDesc2 customink_spline_blk ( customink_params, _T("splineInk"),  0, &splineInkDesc, P_AUTO_CONSTRUCT + P_AUTO_UI, 0, 
	//rollout
	IDD_SPLINEINK, IDS_PW_SPLINEINK, 0, 0, NULL,
	// params
	customink_offset,  _T("offset"), TYPE_FLOAT, 	0, 	IDS_OFFSET, 
		p_default, 		0.0f,	
		p_range, 		-999999.f,999999.f, 
		p_ui,  		TYPE_SPINNER, EDITTYPE_FLOAT, IDC_OFFSET,IDC_OFFSET_SPIN,  1.0f,
		end, 

	customink_size,  _T("size"), TYPE_FLOAT, 	P_RESET_DEFAULT, 	IDS_SIZE, 
		p_default, 		5.0f,	
		p_range, 		0.001f,999999.f, 
		p_ui,  		TYPE_SPINNER, EDITTYPE_FLOAT, IDC_SSIZE,IDC_SIZE_SPIN,  1.0f,
		end, 

	customink_sides,  _T("sides"), TYPE_INT, 	P_RESET_DEFAULT, 	IDS_SIDES, 
		p_default, 		6,	
		p_range, 		3,40, 
		p_ui,  		TYPE_SPINNER, EDITTYPE_INT, IDC_SIDES,IDC_SIDES_SPIN,  1.0f,
		end, 
	customink_renderable,  _T("renderable"), TYPE_INT, 	0, 	IDS_RENDERABLE, 
		p_default, 		TRUE,	
		p_ui,  		TYPE_SINGLECHEKBOX, IDC_RENDERABLE, 
		end, 

	customink_mapping,  _T("mapping"), TYPE_INT, 	0, 	IDS_MAPPING, 
		p_default, 		FALSE,	
		p_ui,  		TYPE_SINGLECHEKBOX, IDC_MAPPING, 
		end, 
	customink_display,  _T("display"), TYPE_INT, 	0, 	IDS_DISPLAY, 
		p_default, 		TRUE,	
		p_ui,  		TYPE_SINGLECHEKBOX, IDC_DISPLAY, 
		end,
	customink_steps,  _T("steps"), TYPE_INT, 	P_RESET_DEFAULT, 	IDS_STEPS, 
		p_default, 		6,	
		p_range, 		0,40, 
		p_ui,  		TYPE_SPINNER, EDITTYPE_INT, IDC_STEPS,IDC_STEPS_SPIN,  1.0f,
		end, 
	customink_offsettype,  _T("offsetType"), TYPE_INT, 	0, 	IDS_OFFSETTYPE, 
		p_default, 		0,	
		p_range, 		0, 2, 
		p_ui, 			TYPE_RADIO, 	3, IDC_RADIO1, IDC_RADIO2, IDC_RADIO3,
		end,

	customink_graph,  _T("graph"),	TYPE_REFTARG, 	P_SUBANIM, 	IDS_PW_GRAPH, 
		end,   

	customink_uselength,  _T("useLength"), TYPE_INT, 	0, 	IDS_USELENGTH, 
		p_default, 		FALSE,	
		p_ui,  		TYPE_SINGLECHEKBOX, IDC_LENGTH_CHECK, 
		end,
	customink_length,  _T("length"), TYPE_FLOAT, 	P_RESET_DEFAULT, 	IDS_LENGTH, 
		p_default, 		50.0f,	
		p_range, 		0.001f,999999.f, 
		p_ui,  		TYPE_SPINNER, EDITTYPE_FLOAT, IDC_LENGTH,IDC_LENGTH_SPIN,  1.0f,
		end, 

	customink_uselimit,  _T("useLimit"), TYPE_INT, 	0, 	IDS_USELIMIT, 
		p_default, 		FALSE,	
		p_ui,  		TYPE_SINGLECHEKBOX, IDC_LIMIT_CHECK, 
		end,
	customink_limit,  _T("limit"), TYPE_INT, 	P_RESET_DEFAULT, 	IDS_LIMIT, 
		p_default, 		50,	
		p_range, 		2,10000, 
		p_ui,  		TYPE_SPINNER, EDITTYPE_INT, IDC_LIMIT,IDC_LIMIT_SPIN,  1.0f,
		end, 


	end
	);


BOOL SplineInkParamsMapDlgProc::DlgProc(
		TimeValue t,IParamMap2 *map,HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam)
			
	{


	switch (msg) {
		case WM_INITDIALOG:
			{
			ReferenceTarget *ref;
			ink->pblock->GetValue(customink_graph,0,(ReferenceTarget *)ref,FOREVER);
			ink->graph = (ICurveCtl *)ref;
			if (ink->graph)
				{
				ink->graph->SetCustomParentWnd(GetDlgItem(hWnd, IDC_GRAPH));
				ink->graph->SetMessageSink(hWnd);
				}
			break;
			}
		case WM_COMMAND:
			{
			switch (LOWORD(wParam)) 
				{


				case IDC_GRAPH:
					{
					if (ink->graph)
						{
						ink->graph->SetCCFlags(CC_ASPOPUP|CC_DRAWBG|CC_DRAWSCROLLBARS|CC_AUTOSCROLL|CC_DRAWUTOOLBAR|
						  CC_DRAWRULER|CC_DRAWGRID|CC_DRAWLTOOLBAR|CC_SHOW_CURRENTXVAL|CC_ALL_RCMENU|CC_SINGLESELECT|CC_NOFILTERBUTTONS);
						if (ink->graph->IsActive())
							ink->graph->SetActive(FALSE);
						else 
							{
							ink->graph->SetActive(TRUE);
							ink->graph->ZoomExtents();
							}

						}

					break;
					}
				}
			break;
			}



		}
	return FALSE;
	}



SplineInkClass::SplineInkClass()
	{
	splineInkDesc.MakeAutoParamBlocks(this);

	
	
	graph = (ICurveCtl *) CreateInstance(REF_MAKER_CLASS_ID,CURVE_CONTROL_CLASS_ID);

	graph->SetXRange(0,1.0f);
	graph->SetYRange(0.0f,1.0f);

	graph->RegisterResourceMaker((ReferenceMaker *)this);
	graph->SetNumCurves(1);
	

	graph->SetTitle(GetString(IDS_PW_GRAPH));
	
	BitArray ba;
	ba.SetSize(1);
	ba.SetAll();
	graph->SetDisplayMode(ba);
	graph->SetCCFlags(CC_ASPOPUP|CC_DRAWBG|CC_DRAWSCROLLBARS|CC_AUTOSCROLL|
					  CC_DRAWRULER|CC_DRAWGRID|
					  CC_RCMENU_MOVE_XY|CC_RCMENU_MOVE_X|CC_RCMENU_MOVE_Y|
					  CC_RCMENU_SCALE|CC_RCMENU_INSERT_CORNER | CC_RCMENU_INSERT_BEZIER|
					CC_RCMENU_DELETE | CC_SHOW_CURRENTXVAL	
					);	

	ICurve *pCurve = NULL;
	
	pCurve = graph->GetControlCurve(0);

	CurvePoint pt;

	pt.flags = CURVEP_CORNER | CURVEP_BEZIER | CURVEP_ENDPOINT;
	pt.out.x = 0.33f;
	pt.out.y = 0.0f;
	pt.in.x = -0.33f;
	pt.in.y = 0.0f;

	pt.p.x = 0.0f;			
	pt.p.y = 0.0f;			
	pCurve->SetPoint(0,0,&pt);
		
	pt.p.x = 1.0f;			
	pt.p.y = 1.0f;			
	pt.in.x = -.33f;
	pt.in.y = 0.0f;
	pt.out.x = .33f;
	pt.out.y = 0.0f;

	pCurve->SetPoint(0,1,&pt);

	pblock->SetValue(customink_graph,0,(ReferenceTarget*)graph);

	
	}
SplineInkClass::~SplineInkClass()
	{
	DeleteAllRefsFromMe();
	}

void SplineInkClass::BeginEditParams(IObjParam  *ip, ULONG flags,Animatable *prev)
	{
	splineInkDesc.BeginEditParams(ip, this, flags, prev);
	customink_spline_blk.SetUserDlgProc(new SplineInkParamsMapDlgProc(this));

	}
void SplineInkClass::EndEditParams(IObjParam *ip,ULONG flags,Animatable *next)
	{
	splineInkDesc.EndEditParams(ip, this, flags, next);
	if (graph->IsActive())
		graph->SetActive(FALSE);
	}


void SplineInkClass::StartStroke( )
	{
	Interval iv;

	pblock->GetValue(customink_offset,0,offset,iv);
	pblock->GetValue(customink_size,0,radius,iv);
	pblock->GetValue(customink_sides,0,sides,iv);

	pblock->GetValue(customink_renderable,0,renderable,iv);
	pblock->GetValue(customink_mapping,0,mapping,iv);
	pblock->GetValue(customink_display,0,display,iv);

	pblock->GetValue(customink_steps,0,steps,iv);

	pblock->GetValue(customink_offsettype,0,offsetType,iv);

	pblock->GetValue(customink_uselength,0,useLength,iv);
	pblock->GetValue(customink_length,0,length,iv);

	pblock->GetValue(customink_uselimit,0,useLimit,iv);
	pblock->GetValue(customink_limit,0,limit,iv);

	pointList.ZeroCount();
	normalList.ZeroCount();
	pressureList.ZeroCount();


	createMatrix = TRUE;
	
	curve = graph->GetControlCurve(0);

	}

BOOL SplineInkClass::ApplyInk(Point3 p,  Point3 surfaceNorm, Point3 bary, DWORD faceIndex,
							Mesh *msh,
							float str, float radius, float pressure, 
							ICurve *pCurve,
							Tab<Point3> &basePoints,	Tab<Point3> &deltaPoints,Tab<Point3> &tempDeltaPoints,
							Matrix3 toWorld, 
							BOOL additive,
							BOOL &updateStack)
	{
	updateStack = FALSE;
	if (createMatrix)
		{
		Matrix3 tm(1);
		MatrixFromNormal(surfaceNorm, tm);
		Point3 tp = p;
		tm.SetTrans(tp);
		toLocalTm = Inverse(tm);
		createMatrix = FALSE;
		}
	Matrix3 mat = (toWorld*toLocalTm);
	Point3 vec = VectorTransform(mat,Normalize(surfaceNorm));
	p = p * mat;
	pointList.Append(1,&p);
	pressureList.Append(1,&pressure);
	normalList.Append(1,&vec);

	return TRUE;
	}

void SplineInkClass::EndStroke()
	{
	theHold.Begin();
	
	Spline3D *Addspline;
	SplineShape *ashape;

	ashape = new SplineShape();
	Addspline = ashape->shape.NewSpline();
	Addspline->SetOpen();
//build distance
	float dist = 0.0f;
	if (offsetType == 1)
		{

		for (int i =1; i < pointList.Count(); i++)
			{
			float l = Length(pointList[i]-pointList[i-1]);
			dist += l;
			}
		}	
	float cur = 0.0f;

	float curLength = 0.0f;
	Point3 lastPoint;


	if (limit < 2) limit = 2;

	int modLimit = pointList.Count()/limit;

	if ( (modLimit == 0) || (!useLimit)) modLimit = 1;

	for (int i =0; i < pointList.Count(); i+=modLimit)
		{
		Point3 p = pointList[i];
		Point3 vec = normalList[i];
		float amount;
		amount = pressureList[i];
		if (offsetType == 0)
			p += vec * offset;
		else if (offsetType == 2)
			p += vec * (amount * offset);
		else
			{
			float per;
			float amount = 0.0f;
			if (i == 0)
				per = 0.0f;
			else
				{
				cur += Length(pointList[i]-pointList[i-1]);
				per = cur/dist;
				amount =  curve->GetValue(0, per);	
				}
			p += vec * (amount * offset);
			}
	
		if ( (i != 0) && (useLength) )
			{
			float l = Length(p-lastPoint);
			curLength += l;
			if (curLength > length)
				{
				float dist = curLength - length ;
				vec = Normalize(p - lastPoint) * dist;
				p = lastPoint + vec;
				i = pointList.Count();
				}
			}

		SplineKnot k(KTYPE_AUTO,LTYPE_CURVE,p,p,p);
		Addspline->AddKnot(k);
		Addspline->ComputeBezPoints();
		lastPoint = p;
		
		}

	Addspline->ComputeBezPoints();

	ashape->SetRenderable(renderable);
	ashape->SetThickness(0, radius);
	ashape->SetSides(0, sides);
	ashape->SetDispRenderMesh(display);
	ashape->SetGenUVs(mapping);

	ashape->shape.steps = steps;

	ashape->shape.UpdateSels();
	ashape->shape.InvalidateGeomCache();

	INode *node = GetCOREInterface()->CreateObjectNode(ashape);
	
	TSTR name(_T("PaintSpline"));
	GetCOREInterface()->MakeNameUnique(name);
	node->SetName(name);
	node->SetNodeTM(GetCOREInterface()->GetTime(),Inverse(toLocalTm));

	GetCOREInterface()->RedrawViews(GetCOREInterface()->GetTime());

	theHold.Accept(TSTR(_T("Create Spline")));
	}

void SplineInkClass::CancelStroke()
	{
	}


