/**********************************************************************
 *<
	FILE: afregion.cpp

	DESCRIPTION:  Affect region modifier

	CREATED BY: Rolf Berteig

	HISTORY: 10/16/96

 *>	Copyright (c) 1994, All Rights Reserved.
 **********************************************************************/

#include "mods.h"







float PaintMod::strength = 2.0f;
float PaintMod::eradius = 30.0f;
float PaintMod::hardness = 1.0f;
float PaintMod::effect = 1.0f;
int PaintMod::inkType = 0;



INT_PTR CALLBACK AddBrushDlgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);


PaintMode*      PaintMod::paintMode = NULL;


static void MatrixFromNormal(Point3& normal, Matrix3& mat)
	{
	Point3 vx;
	vx.z = .0f;
	vx.x = -normal.y;
	vx.y = normal.x;	
	if ( vx.x == .0f && vx.y == .0f ) {
		vx.x = 1.0f;
		}
	mat.SetRow(0,vx);
	mat.SetRow(1,normal^vx);
	mat.SetRow(2,normal);
	mat.SetTrans(Point3(0,0,0));
	mat.NoScale();
	}






//--- ClassDescriptor and class vars ---------------------------------


IObjParam       *PaintMod::ip        = NULL;
		


static PaintClassDesc paintDesc;
extern ClassDesc* GetPaintModDesc() {return &paintDesc;}

static FPInterfaceDesc paintmod_interface(
    PAINTMOD_INTERFACE, _T("paintmod"), 0, &paintDesc, FP_MIXIN,
		paintmod_buttonpaint, _T("buttonPaint"), 0, TYPE_VOID, 0, 0,
		paintmod_buttonresetgraph, _T("buttonResetGraph"), 0, TYPE_VOID, 0, 0,
		paintmod_buttonaddbrush, _T("buttonAddBrush"), 0, TYPE_VOID, 0, 0,
		paintmod_buttonremovebrush, _T("buttonRemoveBrush"), 0, TYPE_VOID, 0, 0,
		paintmod_buttonreset, _T("buttonReset"), 0, TYPE_VOID, 0, 0,

		paintmod_setbrushbyindex, _T("setBrushByIndex"), 0, TYPE_VOID, 0, 1,
			_T("index"), 0, TYPE_INT,
		paintmod_setbrushbyname, _T("setBrushByName"), 0, TYPE_VOID, 0, 1,
			_T("name"), 0, TYPE_STRING,

		paintmod_createbrush, _T("createBrush"), 0, TYPE_INT, 0, 1,
			_T("name"), 0, TYPE_STRING,
		paintmod_removebrush, _T("removeBrush"), 0, TYPE_VOID, 0, 1,
			_T("index"), 0, TYPE_INT,

		paintmod_numberbrushes, _T("numberBrushes"), 0, TYPE_INT, 0, 0,
		paintmod_setbrushgraph, _T("setBrushGraph"), 0, TYPE_VOID, 0, 5,
			_T("index"), 0, TYPE_INT,
			_T("p1"), 0, TYPE_POINT2,
			_T("handle1"), 0, TYPE_POINT2,
			_T("p2"), 0, TYPE_POINT2,
			_T("handle2"), 0, TYPE_POINT2,
		paintmod_setbrushname, _T("setBrushName"), 0, TYPE_VOID, 0, 2,
			_T("index"), 0, TYPE_INT,
			_T("name"), 0, TYPE_STRING,
		paintmod_setbrushstrength, _T("setBrushStrength"), 0, TYPE_VOID, 0, 2,
			_T("index"), 0, TYPE_INT,
			_T("strength"), 0, TYPE_FLOAT,
		paintmod_setbrushradius, _T("setBrushRadius"), 0, TYPE_VOID, 0, 2,
			_T("index"), 0, TYPE_INT,
			_T("radius"), 0, TYPE_FLOAT,
		paintmod_setbrushink, _T("setBrushInk"), 0, TYPE_VOID, 0, 2,
			_T("index"), 0, TYPE_INT,
			_T("ink"), 0, TYPE_INT,
		paintmod_getbrushname, _T("getBrushName"), 0, TYPE_STRING, 0, 1,
			_T("index"), 0, TYPE_INT,
		paintmod_getbrushstrength, _T("getBrushStrength"), 0, TYPE_FLOAT, 0, 1,
			_T("index"), 0, TYPE_INT,
		paintmod_getbrushradius, _T("getBrushRadius"), 0, TYPE_FLOAT, 0, 1,
			_T("index"), 0, TYPE_INT,
		paintmod_getbrushink, _T("getBrushInk"), 0, TYPE_INT, 0, 1,
			_T("index"), 0, TYPE_INT,

      end
      );

FPInterfaceDesc* IPaintMod::GetDesc()
	{
	 return &paintmod_interface;
	}

void *	PaintClassDesc::Create(BOOL loading) 
	{
	AddInterface(&paintmod_interface);
	return new PaintMod();
	}


class PaintModPBAccessor : public PBAccessor
{
public:
	void Set(PB2Value& v, ReferenceMaker* owner, ParamID id, int tabIndex, TimeValue t);    // set from v

};

void PaintModPBAccessor::Set(PB2Value& v, ReferenceMaker* owner, ParamID id, int tabIndex, TimeValue t)    // set from v
	{
		PaintMod* p = (PaintMod*)owner;
		switch (id)
		{
			case paint_inktype:
				SendMessage( p->inkHWND, CB_SETCURSEL, (WPARAM)v.i  , 0 );
				break;

		}
	}

static PaintModPBAccessor paintmod_accessor;

// per instance geosphere block
static ParamBlockDesc2 paint_param_blk ( paint_dparams, _T("Parameters"),  0, &paintDesc, P_AUTO_CONSTRUCT + P_AUTO_UI+ P_MULTIMAP, PBLOCK_REF, 
	3,
	//rollout
	paint_params, IDD_PAINTPARAM, IDS_PARAMETERS, 0, 0, NULL,
	paint_mirror, IDD_PAINTMIRROR, IDS_MIRROR, 0, 0, NULL,
	paint_options, IDD_PAINTOPTIONS, IDS_OPTIONS, 0, 0, NULL,
	// params
	paint_str,  _T("strength"), TYPE_FLOAT, 	P_RESET_DEFAULT, 	IDS_STR, 
		p_default, 		5.0f,	
		p_range, 		-BIGFLOAT,BIGFLOAT, 
		p_ui, 		paint_params,TYPE_SPINNER, EDITTYPE_FLOAT, IDC_STR,IDC_STR_SPIN,  1.0f,
		end, 

	paint_eradius,  _T("radius"), TYPE_FLOAT, 	P_RESET_DEFAULT, 	IDS_RADIUS, 
		p_default, 		15.0f,	
		p_range, 		0.f,BIGFLOAT, 
		p_ui, 		paint_params,TYPE_SPINNER, EDITTYPE_FLOAT, IDC_RADIUS,IDC_RADIUS_SPIN,  1.0f,
		end, 

	paint_hardness,  _T(""), TYPE_FLOAT, 	P_RESET_DEFAULT, 	IDS_HARDNESS, 
		p_default, 		0.0f,	
		p_range, 		0.f,10.f, 
		end, 

	paint_addative, 	_T("addative"),		TYPE_BOOL, 		P_RESET_DEFAULT,	IDS_ADDATIVE,
		p_default, 		FALSE, 
		p_ui, 		paint_params,TYPE_SINGLECHEKBOX, 	IDC_ADDATIVE, 
		end, 

	paint_effect,  _T("effect"), TYPE_FLOAT, 	P_RESET_DEFAULT|P_ANIMATABLE, 	IDS_EFFECT, 
		p_default, 		1.0f,	
		p_range, 		-10.f,10.f, 
		p_ui,  		paint_params,TYPE_SPINNER, EDITTYPE_FLOAT, IDC_EFFECT,IDC_EFFECT_SPIN,  .1f,
		end, 
		

	paint_hittesttype, 	_T("hitTestType"),		TYPE_INT, 		P_RESET_DEFAULT,	IDS_NEWHIT,
		p_default, 		1,	
		p_range, 		0, 2, 
		end, 



	paint_usetablet, 	_T("useTablet"),		TYPE_BOOL, 		P_RESET_DEFAULT,	IDS_USETABLET,
		p_default, 		FALSE, 
		p_ui, 		paint_options,TYPE_SINGLECHEKBOX, 	IDC_TABLET, 
		end, 

	paint_updateonmouseup, 	_T("updateOnMouseUp"),		TYPE_BOOL, 		P_RESET_DEFAULT,	IDS_UPDATE,
		p_default, 		FALSE, 
		p_ui, 		paint_options,TYPE_SINGLECHEKBOX, 	IDC_UPDATE, 
		end, 


	paint_drawring, 	_T("drawRing"),		TYPE_BOOL, 		P_RESET_DEFAULT,	IDS_DRAWRING,
		p_default, 		TRUE, 
		p_ui, 		paint_options,TYPE_SINGLECHEKBOX, 	IDC_RING, 
		end, 

	paint_drawnormal, 	_T("drawNormal"),		TYPE_BOOL, 		P_RESET_DEFAULT,	IDS_DRAWNORMAL,
		p_default, 		TRUE, 
		p_ui, 		paint_options,TYPE_SINGLECHEKBOX, 	IDC_NORMAL, 
		end, 

	paint_drawpressure, 	_T("drawPressure"),		TYPE_BOOL, 		P_RESET_DEFAULT,	IDS_DRAWPRESSURE,
		p_default, 		TRUE, 
		p_ui, 		paint_options,TYPE_SINGLECHEKBOX, 	IDC_PRESSURE, 
		end, 

	paint_colorring,	 _T("ringColor"),	TYPE_RGBA,				P_ANIMATABLE,	IDS_COLORRING,	
		p_default,		Color(1,1,0), 
		p_ui, 		paint_options,			TYPE_COLORSWATCH, IDC_RING_COL, 
		end,

	paint_colornormal,	 _T("normalColor"),	TYPE_RGBA,				P_ANIMATABLE,	IDS_COLORNORMAL,	
		p_default,		Color(0.8,0.8,0.8), 
		p_ui, 		paint_options,			TYPE_COLORSWATCH, IDC_NORMAL_COL, 
		end,
	paint_colorpressure,	 _T("pressureColor"),	TYPE_RGBA,				P_ANIMATABLE,	IDS_COLORPRESSURE,	
		p_default,		Color(0.8,0.0,0.0), 
		p_ui, 		paint_options,			TYPE_COLORSWATCH, IDC_PRESSURE_COL, 
		end,

	paint_lag,  _T("lag"), TYPE_INT, 	P_RESET_DEFAULT, 	IDS_LAG, 
		p_default, 		10,	
		p_range, 		1,50, 
		p_ui, 		paint_options,TYPE_SPINNER, EDITTYPE_INT, IDC_LAG,IDC_LAG_SPIN,  1.0f,
		end, 

	paint_mapsize,  _T("mapSize"), TYPE_FLOAT, 	P_RESET_DEFAULT, 	IDS_MAPSIZE, 
		p_default, 		.2f,	
		p_range, 		0.01f,1.f, 
		end, 

	paint_quadtree,  _T("quadTree"), TYPE_INT, 	P_RESET_DEFAULT, 	IDS_QUADTREE, 
		p_default, 		6,	
		p_range, 		2,10, 
		p_ui, 		paint_options,TYPE_SPINNER, EDITTYPE_INT, IDC_QUADTREE,IDC_QUADTREE_SPIN,  1.0f,
		end, 

	paint_showaffected, 	_T("showAffected"),		TYPE_BOOL, 		P_RESET_DEFAULT,	IDS_SHOWAFFECTED,
		p_default, 		FALSE, 
		p_ui, 		paint_options,TYPE_SINGLECHEKBOX, 	IDC_SHOWAFFECTED, 
		end, 
	paint_falloffcurve, _T("falloffCurve"),			TYPE_REFTARG, 	P_SUBANIM, 	IDS_FALLOFFCURVE,
		end, 

	paint_usemirror, 	_T("useMirror"),		TYPE_BOOL, 		P_RESET_DEFAULT,	IDS_USEMIRROR,
		p_default, 		FALSE, 
		p_ui, 		paint_mirror,TYPE_SINGLECHEKBOX, 	IDC_USEMIRROR, 
		end, 

	paint_offset,  _T("offset"), TYPE_FLOAT, 	P_RESET_DEFAULT, 	IDS_OFFSET, 
		p_default, 		0.0f,	
		p_range, 		-999999.f,999999.f, 
		p_ui,  		paint_mirror,TYPE_SPINNER, EDITTYPE_FLOAT, IDC_OFFSET,IDC_OFFSET_SPIN,  1.0f,
		end, 


	paint_mirrordirection, 	_T("mirrorDirection"),		TYPE_INT, 		P_RESET_DEFAULT,	IDS_MIRRORDIR,
		p_default, 		0,	
		p_range, 		0, 2, 
		p_ui, 			paint_mirror,TYPE_RADIO, 3,IDC_RADIO1,IDC_RADIO2,IDC_RADIO3,
		end, 

	paint_mirrorsize,  _T("mirrorSize"), TYPE_FLOAT, 	P_RESET_DEFAULT, 	IDS_MIRRORSIZE, 
		p_default, 		50.0f,	
		p_range, 		0.f,1000.f, 
		p_ui,  		paint_mirror,TYPE_SPINNER, EDITTYPE_FLOAT, IDC_PSIZE,IDC_PSIZE_SPIN,  1.0f,
		end, 


	paint_affectsize, 	_T("affectSize"),		TYPE_BOOL, 		P_RESET_DEFAULT,	IDS_AFFECTSIZE,
		p_default, 		FALSE, 
		p_ui, 		paint_options,TYPE_SINGLECHEKBOX, 	IDC_AFFECTSIZE_CHECK, 
		end, 

	paint_affectstr, 	_T("affectStr"),		TYPE_BOOL, 		P_RESET_DEFAULT,	IDS_AFFECTSTR,
		p_default, 		TRUE, 
		p_ui, 		paint_options,TYPE_SINGLECHEKBOX, 	IDC_AFFECTSTR_CHECK, 
		end, 

	paint_inktype, 	_T("inkType"),		TYPE_INT, 		0,	IDS_INKTYPE,
		p_default, 		1,
		p_accessor,		&paintmod_accessor,
		end, 

	paint_showvc, 	_T("showVertexColor"),		TYPE_BOOL, 		P_RESET_DEFAULT,	IDS_SHOWVC,
		p_default, 		TRUE, 
		p_ui, 		paint_options,TYPE_SINGLECHEKBOX, 	IDC_VC_CHECK, 
		end, 

	paint_drawstroke, 	_T("paintStroke"),		TYPE_BOOL, 		P_RESET_DEFAULT,	IDS_PAINTSTROKE,
		p_default, 		TRUE, 
		p_ui, 		paint_options,TYPE_SINGLECHEKBOX, 	IDC_DRAWSTROKE, 
		end, 

	paint_custominks,_T("customInks"),		TYPE_REFTARG_TAB, 	0,	0,  IDS_PW_CUSTOMINKS,
		end,

	paint_align, 	_T("alignVec"),		TYPE_BOOL, 		P_RESET_DEFAULT,	IDS_ALIGNVEC,
		p_default, 		TRUE, 
		p_ui, 		paint_options,TYPE_SINGLECHEKBOX, 	IDC_ALIGNVEC, 
		end, 


	end
	);



#define PARAMDESC_LENGTH	5

static ParamBlockDescID descVer0[] = {
	{ TYPE_FLOAT, NULL, FALSE,  paint_str },		// Falloff	
	{ TYPE_FLOAT, NULL, FALSE,  paint_eradius },		// Settle	
	{ TYPE_FLOAT, NULL, FALSE,  paint_hardness },		// Waves
	{ TYPE_INT, NULL, FALSE,  paint_addative },		// Addative
	};
static ParamBlockDescID descVer1[] = {
	{ TYPE_FLOAT, NULL, FALSE,  paint_str },		// Falloff	
	{ TYPE_FLOAT, NULL, FALSE,  paint_eradius },		// Settle	
	{ TYPE_FLOAT, NULL, FALSE,  paint_hardness },		// Waves
	{ TYPE_INT, NULL, FALSE,  paint_addative },		// Addative
	{ TYPE_INT, NULL, TRUE,  paint_effect },		// Effect
	};
#define PBLOCK_LENGTH	5

#define CURRENT_VERSION	1

// Array of old versions
static ParamVersionDesc versions[] = {
	ParamVersionDesc(descVer0,3,0),
	};
#define NUM_OLDVERSIONS	1


#ifdef USETABLET

HCTX static NEAR TabletInit(HWND hWnd, PaintMod *mod)
{
	LOGCONTEXT lcMine;

	if(mod->hWinTabDLL == NULL) return NULL;

	UINT p,rp; 
	rp = mod->PaintWTInfo(WTI_DEVICES, DVC_NPRESSURE, &p );


	/* get default region */
	mod->PaintWTInfo(WTI_DEFCONTEXT, 0, &lcMine);

	/* modify the digitizing region */
	wsprintf(lcMine.lcName, "PrsTest Digitizing %x", hInstance);
	lcMine.lcOptions |= CXO_MESSAGES|CXO_SYSTEM;
	lcMine.lcPktData = PACKETDATA;
	lcMine.lcPktMode = PACKETMODE;
	lcMine.lcMoveMask = PACKETDATA;
	lcMine.lcBtnUpMask = lcMine.lcBtnDnMask;

	/* output in 10000 x 10000 grid */
	lcMine.lcOutOrgX = lcMine.lcOutOrgY = 0;
	lcMine.lcOutExtX = 10000;
	lcMine.lcOutExtY = 10000;

	/* open the region */
	if (mod->hWinTabDLL)
		return mod->PaintWTOpen(hWnd, &lcMine, TRUE);
	else return NULL;

}

#endif

//--- MapDlgProc -----------------------------------------------------

class PaintDlgProc : public ParamMap2UserDlgProc {
	public:
		PaintMod *mod;		
		PaintDlgProc(PaintMod *m) {mod = m;}		
		BOOL DlgProc(TimeValue t,IParamMap2 *map,HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam);		
		void DeleteThis() {delete this;}
	};


BOOL PaintDlgProc::DlgProc(
		TimeValue t,IParamMap2 *map,HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam)
	{
	int id = LOWORD(wParam);
	int code = HIWORD(wParam);

#ifdef USETABLET
	static HCTX hTab = NULL;
	PACKET pkt;
	static UINT prsOld, prsNew;
#endif


	switch (msg) {
		case WM_INITDIALOG:
			mod->hWnd = hWnd;
			mod->pblock->GetValue(paint_inktype,0,mod->inkType,FOREVER);
			SendMessage(GetDlgItem(hWnd,IDC_PAINT),CC_COMMAND,CC_CMD_SET_TYPE,CBT_CHECK);
//fillout combo box
			mod->inkHWND = GetDlgItem(hWnd, IDC_INK);
			SendMessage(mod->inkHWND, CB_ADDSTRING, 0, (LPARAM)"Move Normal");
			SendMessage(mod->inkHWND, CB_ADDSTRING, 0, (LPARAM)"Move Original Normal");
			SendMessage(mod->inkHWND, CB_ADDSTRING, 0, (LPARAM)"Scale");
			SendMessage(mod->inkHWND, CB_ADDSTRING, 0, (LPARAM)"Smooth");
			SendMessage(mod->inkHWND, CB_ADDSTRING, 0, (LPARAM)"Move Z Local");
			SendMessage(mod->inkHWND, CB_ADDSTRING, 0, (LPARAM)"Move XY Local");
			SendMessage(mod->inkHWND, CB_ADDSTRING, 0, (LPARAM)"Move Z Screen");
			SendMessage(mod->inkHWND, CB_ADDSTRING, 0, (LPARAM)"Move XY Screen");
			SendMessage(mod->inkHWND, CB_ADDSTRING, 0, (LPARAM)"Select Verts");
			SendMessage(mod->inkHWND, CB_ADDSTRING, 0, (LPARAM)"Select Faces");


			mod->SetCustomInk();

			SendMessage( mod->inkHWND, CB_SETCURSEL, (WPARAM) mod->inkType , 0 );

			if (mod->inkType >(NUMBER_DEFAULTINKS-1))
				{
				int cInk = mod->inkType -NUMBER_DEFAULTINKS;
				if ((cInk >=0) && (cInk < mod->pblock->Count(paint_custominks)))
					{
					Interval iv;
					ReferenceTarget *ref;
					mod->pblock->GetValue(paint_custominks,0,ref,iv,cInk);
					IInkClass *customInk = (IInkClass*) ref;
					if (customInk) 
						{
						customInk->BeginEditParams(mod->ip, mod->customInkFlags,NULL);
						mod->currentInk = customInk;
						}
					}
				else
					{
					mod->inkType = 0;
					mod->pblock->SetValue(paint_inktype,0,mod->inkType);
					SendMessage( mod->inkHWND, CB_SETCURSEL, (WPARAM) mod->inkType , 0 );

					}
				}

#ifdef USETABLET
			mod->LoadWinTabDLL();
			hTab = TabletInit(hWnd,mod);
/*
			if (!hTab) {
				MessageBox(NULL, " Could Not Open Tablet Context.", "WinTab",
							MB_OK | MB_ICONHAND);
			}
*/
#endif

			ReferenceTarget *ref;

			mod->pblock->GetValue(paint_falloffcurve,0,ref, FOREVER);
			mod->curveCtl = (ICurveCtl *) ref;


			mod->curveCtl->SetCustomParentWnd(GetDlgItem(hWnd, IDC_CURVE));
			mod->curveCtl->SetMessageSink(hWnd);
			mod->curveCtl->SetActive(TRUE);
			mod->pCurve = mod->curveCtl->GetControlCurve(0);

			mod->FilloutBrushList();

			break;




#ifdef USETABLET
		case WT_PACKET:
			if (mod->useTablet)
				{
				if ((mod->hWinTabDLL) && (mod->PaintWTPacket((HCTX)lParam, wParam, &pkt)) )
					{
					if (mod->inPaint)
						{
						if (HIWORD(pkt.pkButtons)==TBN_DOWN) 
							{
							mod->strokeState = STARTSTROKE;
							}
						else if (HIWORD(pkt.pkButtons)==TBN_UP) 
							{
							mod->strokeState = ENDSTROKE;
							mod->fpressure  = 1.0f;
							}

						mod->pressure = pkt.pkNormalPressure;
						mod->fpressure = (float)(mod->pressure)/1024.0f;
				
						TSTR name;
						name.printf("%1.2f (%d)",mod->fpressure,mod->pressure);
						SetWindowText(GetDlgItem(hWnd,IDC_WEIGHT),name);
	
						if (mod->pressure != 0) mod->strokeState = INSTROKE;
						}
					}
				}
			else mod->fpressure  = 1.0f;
			
			break;
#endif


		case WM_COMMAND:
			switch (LOWORD(wParam)) {
			case IDC_BRUSHLIST :
				{
				if (code == CBN_SELCHANGE)
					mod->SetBrush();
				break;
						
				}
			case IDC_ADDBRUSH:
				{
				macroRecorder->FunctionCall(_T("$.modifiers[#Paint_Modifier].buttonAddBrush"), 0, 0);
				mod->AddBrush();
				break;
				}
			case IDC_REMOVEBRUSH:
				{
				macroRecorder->FunctionCall(_T("$.modifiers[#Paint_Modifier].buttonRemoveBrush"), 0, 0);
				mod->RemoveBrush();
				break;
				}
			case IDC_RESETGRAPH:
				{
				macroRecorder->FunctionCall(_T("$.modifiers[#Paint_Modifier].buttonResetGraph"), 0, 0);
				mod->ResetGraph();
				break;
				}
			case IDC_PAINT:
				{
				macroRecorder->FunctionCall(_T("$.modifiers[#Paint_Modifier].buttonPaint"), 0, 0);

				if (mod->ip->GetCommandMode()->ID()==CID_PAINT) {
					mod->ip->SetStdCommandMode(CID_OBJMOVE);
				} else {
					mod->ip->SetCommandMode(mod->paintMode);
					}
				break;
				}
			case IDC_INK: 
				{
				if (code==CBN_SELCHANGE) 
					{

					if (mod->inkType >(NUMBER_DEFAULTINKS-1))
						{
						int cInk = mod->inkType -NUMBER_DEFAULTINKS;
						Interval iv;
						ReferenceTarget *ref;
						mod->pblock->GetValue(paint_custominks,0,ref,iv,cInk);
						IInkClass *customInk = (IInkClass*) ref;
						if (customInk) customInk->EndEditParams(mod->ip, END_EDIT_REMOVEUI,NULL);
						}

					mod->inkType = SendMessage( GetDlgItem(hWnd,IDC_INK), CB_GETCURSEL, 0, 0 );

					if (mod->inkType >(NUMBER_DEFAULTINKS-1))
						{
						int cInk = mod->inkType -NUMBER_DEFAULTINKS;
						Interval iv;
						ReferenceTarget *ref;
						mod->pblock->GetValue(paint_custominks,0,ref,iv,cInk);
						IInkClass *customInk = (IInkClass*) ref;
						if (customInk) 
							{
							mod->currentInk = customInk;
							customInk->BeginEditParams(mod->ip, mod->customInkFlags,NULL);
							}
						}

					theHold.Suspend();
					mod->pblock->SetValue(paint_inktype,0,mod->inkType);
					theHold.Resume();
					}
				break;
				}
			case IDC_RESET: 
				{

				macroRecorder->FunctionCall(_T("$.modifiers[#Paint_Modifier].buttonReset"), 0, 0);
				mod->ResetVerts();
				break;
				}
			case IDC_HELPBUTTON:
				ShellExecute(GetCOREInterface()->GetMAXHWnd(), "open", "iexplore.exe", "www.max3dstuff.com/max4/paintDeformMod/helpEx.html", NULL, SW_SHOWNORMAL);
				break;

				}
			break;
		}
	return FALSE;
	}


class OptionDlgProc : public ParamMap2UserDlgProc {
	public:
		PaintMod *mod;		
		OptionDlgProc(PaintMod *m) {mod = m;}		
		BOOL DlgProc(TimeValue t,IParamMap2 *map,HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam);		
		void DeleteThis() {delete this;}
	};


BOOL OptionDlgProc::DlgProc(
		TimeValue t,IParamMap2 *map,HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam)
	{

	switch (msg) {
		case WM_INITDIALOG:
			break;





		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case IDC_HELPBUTTON:
					ShellExecute(GetCOREInterface()->GetMAXHWnd(), "open", "iexplore.exe", "www.max3dstuff.com/max4/paintDeformMod/helpEx.html", NULL, SW_SHOWNORMAL);
					break;


				}
			break;
		}
	return FALSE;
	}



//--- Affect region mod methods -------------------------------

PaintMod::PaintMod() 
	{
	hWinTabDLL = NULL;
	PaintWTPacket = NULL;
	PaintWTOpen = NULL;
	PaintWTInfo = NULL;


	curveCtl = NULL;
	GetPaintModDesc()->MakeAutoParamBlocks(this);

	sel[0] = 0;
	pblock->SetValue(paint_str,0,strength);
	pblock->SetValue(paint_eradius,0,eradius);
	pblock->SetValue(paint_hardness,0,hardness);
	pblock->SetValue(paint_effect,0,effect);
	inkType = 0;
	inPaint = FALSE;
#ifdef USETABLET
	strokeState = OUTOFSTROKE;
#endif


	curveCtl = (ICurveCtl *) CreateInstance(REF_MAKER_CLASS_ID,CURVE_CONTROL_CLASS_ID);
	pblock->SetValue(paint_falloffcurve,0,curveCtl);

	curveCtl->SetXRange(0.0f,1.0f);
	curveCtl->SetYRange(-1.5f,1.5f);

	curveCtl->RegisterResourceMaker((ReferenceMaker *)this);

	curveCtl->SetNumCurves(1);
	curveCtl->SetZoomValues(110.0f,60.4f);
	curveCtl->SetScrollValues(-14,-29);

	BitArray ba;
	ba.SetSize(1);
	ba.Set(0);//ba.Set(0);ba.Set(0);ba.Set(3);
	curveCtl->SetDisplayMode(ba);
	
	DWORD flags = CC_NONE;
	
	flags |=  CC_DRAWBG ;
	flags |=  CC_DRAWGRID ;
	flags |=  CC_DRAWUTOOLBAR ;
	flags |=  CC_AUTOSCROLL ;
	
	
	flags |=  CC_RCMENU_MOVE_XY ;
	flags |=  CC_RCMENU_MOVE_X ;
	flags |=  CC_RCMENU_MOVE_Y ;
	flags |=  CC_RCMENU_SCALE ;
	flags |=  CC_RCMENU_INSERT_CORNER ;
	flags |=  CC_RCMENU_INSERT_BEZIER ;
	flags |=  CC_RCMENU_DELETE ;

	curveCtl->SetCCFlags(flags);

	ICurve *pCurve = NULL;
	
	pCurve = curveCtl->GetControlCurve(0);

	CurvePoint pt;

	pt.flags = CURVEP_CORNER | CURVEP_BEZIER | CURVEP_ENDPOINT;
	pt.out.x = 0.33f;
	pt.out.y = 0.0f;
	pt.in.x = -0.33f;
	pt.in.y = 0.0f;

	pt.p.x = 0.0f;			
	pt.p.y = 1.0f;			
	pCurve->SetPoint(0,0,&pt);
		
	pt.p.x = 1.0f;			
	pt.p.y = 0.0f;			
	pt.in.x = -.33f;
	pt.in.y = 0.0f;
	pt.out.x = .33f;
	pt.out.y = 0.0f;

	pCurve->SetPoint(0,1,&pt);
	pCurve->SetLookupTableSize(100);
	
//	curveCtl->SetCustomParentWnd(GetDlgItem(hPanel, IDC_CURVE));
//	curveCtl->SetMessageSink(hPanel);


	}

void PaintMod::EnterPaintAlign()
	{	
	SendMessage(GetDlgItem(hWnd,IDC_PAINT),CC_COMMAND,CC_CMD_SET_STATE,1);
	}

void PaintMod::ExitPaintAlign()
	{	
	SendMessage(GetDlgItem(hWnd,IDC_PAINT),CC_COMMAND,CC_CMD_SET_STATE,0);
	}


void PaintMod::BeginEditParams(
		IObjParam  *ip, ULONG flags,Animatable *prev)
	{
	customInkFlags = flags;

	ModContextList mcList;
	INodeTab nodeList;

	ip->GetModContexts(mcList,nodeList);
	
	for (int i = 0; i < nodeList.Count(); i++)
		{
//get node list
		PaintModData* pmd = GetPMDFromNode(nodeList[i]);
		if (pmd)
			{
			pmd->rebuildOriginalNorms = TRUE;
			pmd->redoNormalList = TRUE;
			}
		}
	nodeList.DisposeTemporary();

	fpressure  = 1.0f;

	this->ip = ip;
	// Add our sub object type
	TSTR type1(GetString(IDS_RB_AFRPOINTS));

	// Create sub object editing modes.

	paintMode = new PaintMode(this,ip);

	
	TimeValue t = ip->GetTime();
	NotifyDependents(Interval(t,t), PART_ALL, REFMSG_BEGIN_EDIT);
	NotifyDependents(Interval(t,t), PART_ALL, REFMSG_MOD_DISPLAY_ON);
	SetAFlag(A_MOD_BEING_EDITED);


	paintDesc.BeginEditParams(ip, this, flags, prev);
	paint_param_blk.SetUserDlgProc(paint_params,new PaintDlgProc(this));
	paint_param_blk.SetUserDlgProc(paint_options,new OptionDlgProc(this));

	

	}

void PaintMod::EndEditParams(
		IObjParam *ip,ULONG flags,Animatable *next)
	{
	this->ip = NULL;
	TimeValue t = ip->GetTime();

	// NOTE: This flag must be cleared before sending the REFMSG_END_EDIT
	ClearAFlag(A_MOD_BEING_EDITED);

	NotifyDependents(Interval(t,t), PART_ALL, REFMSG_END_EDIT);
	NotifyDependents(Interval(t,t), PART_ALL, REFMSG_MOD_DISPLAY_OFF);

	ip->DeleteMode(paintMode);
	delete paintMode; paintMode = NULL;

	paintDesc.EndEditParams(ip, this, flags, next);

	if (inkType > (NUMBER_DEFAULTINKS-1))
		{
		int cInk = inkType -NUMBER_DEFAULTINKS;
		Interval iv;
		ReferenceTarget *ref;
		pblock->GetValue(paint_custominks,0,ref,iv,cInk);
		IInkClass *customInk = (IInkClass*) ref;
		if (customInk) customInk->EndEditParams(ip, END_EDIT_REMOVEUI,NULL);
		}

	ModContextList mcList;
	INodeTab nodeList;

	ip->GetModContexts(mcList,nodeList);
	
	for (int i = 0; i < nodeList.Count(); i++)
		{
//get node list
		PaintModData* pmd = GetPMDFromNode(nodeList[i]);
		if (pmd)
			{
			pmd->FreeTempData();
			}
		}
	nodeList.DisposeTemporary();



	UnLoadWinTabDLL();

	}

RefTargetHandle PaintMod::Clone(RemapDir& remap)
	{
	PaintMod *mod = new PaintMod();
	mod->ReplaceReference(PBLOCK_REF,pblock->Clone(remap));
	BaseClone(this, mod, remap);
	return mod;
	}




void PaintMod::ResetGraph()
	{

	ReferenceTarget *ref;

	pblock->GetValue(paint_falloffcurve,0,ref, FOREVER);
	curveCtl = (ICurveCtl *) ref;

	curveCtl->SetXRange(0.0f,1.0f);
	curveCtl->SetYRange(-1.5f,1.5f);

	curveCtl->SetNumCurves(1);
	curveCtl->SetZoomValues(110.0f,60.4f);
	curveCtl->SetScrollValues(-14,-29);

	BitArray ba;
	ba.SetSize(1);
	ba.Set(0);//ba.Set(0);ba.Set(0);ba.Set(3);
	curveCtl->SetDisplayMode(ba);
	

	ICurve *pCurve = NULL;
	

	pCurve = curveCtl->GetControlCurve(0);

	pCurve->SetNumPts(2);
	CurvePoint pt;

	pt.flags = CURVEP_CORNER | CURVEP_BEZIER | CURVEP_ENDPOINT;
	pt.out.x = 0.33f;
	pt.out.y = 0.0f;
	pt.in.x = -0.33f;
	pt.in.y = 0.0f;

	pt.p.x = 0.0f;			
	pt.p.y = 1.0f;			
	pCurve->SetPoint(0,0,&pt);
		
	pt.p.x = 1.0f;			
	pt.p.y = 0.0f;			
	pt.in.x = -.33f;
	pt.in.y = 0.0f;
	pt.out.x = .33f;
	pt.out.y = 0.0f;

	pCurve->SetPoint(0,1,&pt);
	pCurve->SetLookupTableSize(100);

	curveCtl->Redraw();
	}

void PaintMod::ResetVerts()
	{
//get local mod list
	ModContextList mcList;
	INodeTab nodeList;

	ip->GetModContexts(mcList,nodeList);
	theHold.Begin();
	
	for (int i = 0; i < nodeList.Count(); i++)
		{
//get node list
		PaintModData* pmd = GetPMDFromNode(nodeList[i]);
		if (pmd)
			{
			theHold.Put(new MoveRestore(this,pmd));
			pmd->redoNormalList=TRUE;
			Point3 p(0.0f,0.0f,0.0f);
			pmd->selectedFaceList.ClearAll();;
			for (int j = 0; j < pmd->DeltaList.Count(); j++)
				{
				pmd->DeltaList[j] = p;
				pmd->SelectVertList[j] = 0.0f;
				}

			}
		}


	theHold.Accept(TSTR(_T("Paint Deform")));

	Point3 p(0.0f,0.0f,0.0f);
	BOOL b = FALSE;
	for (i = 0; i < DeltaListOld.Count(); i++)
		{
		DeltaListOld[i] = p;
		SelectVertListOld[i] = 0;
		}

	nodeList.DisposeTemporary();


	NotifyDependents(Interval(GetCOREInterface()->GetTime(),GetCOREInterface()->GetTime()), PART_GEOM, REFMSG_MOD_EVAL);
	GetCOREInterface()->RedrawViews(GetCOREInterface()->GetTime(),REDRAW_NORMAL);
	}



void PaintMod::ShadeVerts(Mesh *msh)
	{

	if (ip)
		{
		int nv = msh->getNumVerts();
		msh->setNumVCFaces(msh->getNumFaces());
		msh->setNumVertCol(nv);
		int nf = msh->getNumFaces();
		Point3 selSoft = GetUIColor(COLOR_SUBSELECTION_SOFT);
		Point3 selMedium = GetUIColor(COLOR_SUBSELECTION_MEDIUM);
		Point3 selHard = GetUIColor(COLOR_SUBSELECTION_HARD);
		Point3 selSubColor = GetUIColor(COLOR_SUBSELECTION);

		float *vsw = msh->getVSelectionWeights ();
		for (int i=0;i<msh->getNumVerts();i++)
			{
			float infl = vsw[i];

			Color selColor(1.0f,1.0f,1.0f);
			if (infl > 0.0f)
				{
				if ( (infl<0.33f) && (infl > 0.0f))
					{
					selColor = selSoft + ( (selMedium-selSoft) * (infl/0.33f));
					}
				else if (infl <.66f)
					{
					selColor = selMedium + ( (selHard-selMedium) * ((infl-0.1f)/0.66f));
					}
				else if (infl < 0.99f)
					{
					selColor = selHard + ( (selSubColor-selHard) * ((infl-0.66f)/0.33f));
					}
				else 
					{
					selColor = selSubColor;
					}
				msh->vertCol[i] = selColor;

				}
			}
		
				

		for (i=0; i < nf; i++)
			{
			msh->vcFace[i].t[0] = msh->faces[i].v[0];
			msh->vcFace[i].t[1] = msh->faces[i].v[1];
			msh->vcFace[i].t[2] = msh->faces[i].v[2];
			}

		}
		
}

PaintModData* PaintMod::GetPMDFromNode(INode *node)
{
	SClass_ID		sc;
	IDerivedObject* dobj;

	BOOL found = FALSE;

	Object* obj = node->GetObjectRef();
	int ct = 0;

	if ((sc = obj->SuperClassID()) == GEN_DERIVOB_CLASS_ID)
		{
		dobj = (IDerivedObject*)obj;
		while (sc == GEN_DERIVOB_CLASS_ID)
			{
			for (int j = 0; j < dobj->NumModifiers(); j++)
				{
				if (dobj->GetModifier(j) == this)
					{
					ModContext *mc = dobj->GetModContext(j);
					if ((mc) && (mc->localData))
						return (PaintModData*) mc->localData;
					}

				}
			dobj = (IDerivedObject*)dobj->GetObjRef();
			sc = dobj->SuperClassID();

			}

		}
	return NULL;

}

INode* PaintMod::GetNodeFromModContext(ModContext *smd)
	{

	int				i;
	SClass_ID		sc;
	IDerivedObject* dobj;

    MyEnumProc dep;              
	EnumDependents(&dep);
	for ( i = 0; i < dep.Nodes.Count(); i++)
		{
		INode *node = dep.Nodes[i];
		BOOL found = FALSE;

		Object* obj = node->GetObjectRef();
		int ct = 0;

		if ((sc = obj->SuperClassID()) == GEN_DERIVOB_CLASS_ID)
			{
			dobj = (IDerivedObject*)obj;
			while (sc == GEN_DERIVOB_CLASS_ID)
				{
				for (int j = 0; j < dobj->NumModifiers(); j++)
					{
					ModContext *mc = dobj->GetModContext(j);
					if (mc == smd)
						{
						return node;
						}

					}
				dobj = (IDerivedObject*)dobj->GetObjRef();
				sc = dobj->SuperClassID();

				}

			}
		}
	return NULL;
	}



void PaintMod::ModifyObject(
		TimeValue t, ModContext &mc, ObjectState *os, INode *node)
	{	

	if (mc.localData == NULL)
		{
		mc.localData = new PaintModData();
		}
	PaintModData *pmd = (PaintModData *) mc.localData;
	int nv = os->obj->NumPoints();

	if ( (pmd->DeltaList.Count() == 0) ||(pmd->DeltaList.Count() != nv))
		{
		Point3 p(0.0f,0.0f,0.0f);
		float b = 0.0f;
		pmd->selectedFaceList.ClearAll();
		for (int i = 0; i < nv; i++)
			{
			pmd->DeltaList.Append(1,&p,1);
			pmd->TempList.Append(1,&p,1);
			pmd->SelectVertList.Append(1,&b,1);
			}
		pmd->rebuildOriginalNorms = TRUE;
		pmd->redoNormalList = TRUE;
		}


	Interval valid = FOREVER;

	pblock->GetValue(paint_str,t,strength,valid);		
	pblock->GetValue(paint_eradius,t,eradius,valid);		
	pblock->GetValue(paint_hardness,t,hardness,valid);		
	pblock->GetValue(paint_addative,t,Addative,valid);		
	pblock->GetValue(paint_effect,t,effect,valid);		

	pblock->GetValue(paint_drawring,t,drawRing,valid);
	pblock->GetValue(paint_drawnormal,t,drawNormal,valid);
	pblock->GetValue(paint_drawpressure,t,drawPressure,valid);

	pblock->GetValue(paint_colorring,t,ringColor,valid);
	pblock->GetValue(paint_colornormal,t,normalColor,valid);
	pblock->GetValue(paint_colorpressure,t,pressureColor,valid);

	pblock->GetValue(paint_usetablet,t,useTablet,valid);
	pblock->GetValue(paint_updateonmouseup,t,updateOnMouseUp,valid);
	pblock->GetValue(paint_hittesttype,t,hitTestType,valid);
	
	pblock->GetValue(paint_lag,t,lag,valid);
	pblock->GetValue(paint_mapsize,t,mapSize,valid);
	pblock->GetValue(paint_quadtree,t,quadTree,valid);

	pblock->GetValue(paint_showaffected,t,showAffected,valid);

	   
	pblock->GetValue(paint_usemirror,t,useMirror,valid);
	pblock->GetValue(paint_offset,t,offset,valid);
	pblock->GetValue(paint_mirrordirection,t,mirrorDir,valid);

	pblock->GetValue(paint_mirrorsize,t,mirrorDispSize,valid);


	pblock->GetValue(paint_affectsize,t,affectSize,valid);
	pblock->GetValue(paint_affectstr,t,affectStr,valid);


	pblock->GetValue(paint_inktype,t,inkType,valid);
	pblock->GetValue(paint_showvc,t,showVC,valid);

	pblock->GetValue(paint_drawstroke,t,paintStroke,valid);

	pblock->GetValue(paint_align,t,alignVec,valid);

	

	strengthsquared = (float) fabs(strength);

	eradiussquared = eradius * eradius;


	Interval iv = os->obj->ChannelValidity (t, GEOM_CHAN_NUM);
	iv &= os->obj->ChannelValidity (t, SELECT_CHAN_NUM);
	iv &= os->obj->ChannelValidity (t, SUBSEL_TYPE_CHAN_NUM);

	if (os->obj->IsSubClassOf(triObjectClassID))
		pmd->objectType = PAINTMESH_OBJECT;
	else if (os->obj->IsSubClassOf(patchObjectClassID))
		pmd->objectType = PAINTPATCH_OBJECT;
	else if (os->obj->IsSubClassOf(EDITABLE_SURF_CLASS_ID))
		pmd->objectType = PAINTNURBS_OBJECT;
	else if (os->obj->IsSubClassOf(polyObjectClassID))
		pmd->objectType = PAINTPOLY_OBJECT;

//object type nurbs or patch
	if (pmd->rebuildOriginalNorms)
		{
		if ( (os->obj->IsSubClassOf(triObjectClassID)) && ip)
			{
			TriObject *tobj = (TriObject*)os->obj;
			pmd->BuildONormals(&tobj->mesh);
			}
		else if(os->obj->CanConvertToType(triObjectClassID) && ip) 
			{
			TriObject *tobj = (TriObject *)os->obj->ConvertToType(t, triObjectClassID);
			Mesh msh = tobj->GetMesh();
			pmd->BuildONormals(&msh);
	
			if (tobj != os->obj) tobj->DeleteThis();			
			}
		
		
		}

	PaintDeformer deformer(this,pmd);
	os->obj->Deform(&deformer, TRUE);

	float *vsw;
	TriObject *tobj = NULL;
	if ((inkType == INK_SELECTVERTS) && (os->obj->IsSubClassOf(triObjectClassID)))
		{
		tobj = (TriObject*)os->obj;
		tobj->mesh.vertSel.ClearAll();
		tobj->mesh.SupportVSelectionWeights();
		tobj->mesh.selLevel = MESH_VERTEX;
		tobj->mesh.SetDispFlag(DISP_VERTTICKS | DISP_SELVERTS);
		vsw = tobj->mesh.getVSelectionWeights ();	// NULL if none.
		tobj->mesh.vertSel.ClearAll();
		}
	


	if ((inkType == INK_SELECTVERTS) && (os->obj->IsSubClassOf(triObjectClassID)))
		{
		for (int i = 0; i<os->obj->NumPoints() ;i++)
		
		
			{
			if (pmd->SelectVertList[i] >= 1.0f)
				tobj->mesh.vertSel.Set(i);
			vsw[i] = pmd->SelectVertList[i];
			}
		}

	if ((inkType == INK_SELECTFACES) && (os->obj->IsSubClassOf(triObjectClassID)))
		{
		tobj = (TriObject*)os->obj;
		tobj->mesh.faceSel.ClearAll();
		tobj->mesh.selLevel = MESH_FACE;
		tobj->mesh.SetDispFlag( DISP_SELFACES);
		tobj->mesh.faceSel = pmd->selectedFaceList;
		}
	



//object type nurbs or patch
	if (hitTestType ==HITTEST_RAYCAST)
		{
		pmd->isMesh = FALSE;
		}
	else if ( (os->obj->IsSubClassOf(triObjectClassID)) && ip)
		{
		pmd->isMesh = TRUE;
		TriObject *tobj = (TriObject*)os->obj;
		if  (pmd->redoNormalList) 
			{
			pmd->BuildNormals(&tobj->mesh);
			pmd->msh = tobj->mesh;

	//get node from the mode context	
			INode *node = GetNodeFromModContext(&mc);

			pmd->meshSearchTree.SetNormalizeMesh(FALSE);
			pmd->meshSearchTree.SetDepth(quadTree);
			ViewExp *vpt = ip->GetActiveViewport();
			Matrix3 tm, basetm;
			basetm = node->GetObjectTM(t);
			vpt->GetAffineTM(tm);

			viewTM = tm;
			viewhWnd = vpt->GetHWnd();
			pmd->backTm = Inverse(tm);// * Inverse(basetm);

			TCHAR *n = node->GetName();

			if (hitTestType ==HITTEST_QUADTREE)
				{
				mapSize = 1.0f;
				pmd->meshSearchTree.BuildTree(&pmd->msh,basetm,tm,vpt,mapSize, FALSE);
				}
			else if (hitTestType ==HITTEST_ZBUFFER)
				pmd->meshSearchTree.BuildTree(&pmd->msh,basetm,tm,vpt,mapSize, TRUE);

			ip->ReleaseViewport(vpt);
			pmd->redoNormalList = FALSE;

			}
	
		}
	else if(os->obj->CanConvertToType(triObjectClassID) && ip) 
		{

		pmd->isMesh = TRUE;
		if  (pmd->redoNormalList) 
			{
			TriObject *tobj = (TriObject *)os->obj->ConvertToType(t, triObjectClassID);
			pmd->msh = tobj->GetMesh();
			pmd->BuildNormals(&pmd->msh);
	
			INode *node = GetNodeFromModContext(&mc);

			pmd->meshSearchTree.SetNormalizeMesh(FALSE);
			pmd->meshSearchTree.SetDepth(quadTree);
			ViewExp *vpt = ip->GetActiveViewport();
			Matrix3 tm, basetm;
			basetm = node->GetObjectTM(t);
			vpt->GetAffineTM(tm);

			viewTM = tm;
			viewhWnd = vpt->GetHWnd();
//			tm = basetm * tm;
			pmd->backTm = Inverse(tm);// * Inverse(basetm);

			if (hitTestType ==HITTEST_QUADTREE)
				{
				mapSize = 1.0f;
				pmd->meshSearchTree.BuildTree(&pmd->msh,basetm,tm,vpt,mapSize, FALSE);
				}
			else if (hitTestType ==HITTEST_ZBUFFER)
				pmd->meshSearchTree.BuildTree(&pmd->msh,basetm,tm,vpt,mapSize, TRUE);

			ip->ReleaseViewport(vpt);
			pmd->redoNormalList = FALSE;
			if (tobj != os->obj) tobj->DeleteThis();			
			}
		
		
		}


	else pmd->isMesh = FALSE;

//object type nurbs or patch
	if (pmd->rebuildOriginalNorms)
		{
		pmd->rebuildOriginalNorms = FALSE;
		pmd->meshSearchTree.BuildVertLoops();
		}

	if (pmd->setPoints)
		{
		int ct = pmd->oPointList.Count();
		if (ct != os->obj->NumPoints())  pmd->oPointList.SetCount(os->obj->NumPoints());
		ct = pmd->oPointList.Count();
		for (int vc = 0; vc < ct;vc++)
			pmd->oPointList[vc] = os->obj->GetPoint(vc);
		pmd->setPoints = FALSE;
		}



	os->obj->PointsWereChanged();
	os->obj->UpdateValidity (GEOM_CHAN_NUM, iv);
//	os->obj->UpdateValidity (TOPO_CHAN_NUM, iv);
	os->obj->UpdateValidity (SELECT_CHAN_NUM, iv);
	os->obj->UpdateValidity (SUBSEL_TYPE_CHAN_NUM, iv);
//	os->obj->UpdateValidity (TEXMAP_CHAN_NUM, iv);
//	os->obj->UpdateValidity (VERT_COLOR_CHAN_NUM, iv);

	}

Interval PaintMod::LocalValidity(TimeValue t)
	{
	Interval iv = FOREVER;
	Point3 pt;
	iv.Set(t,t);
	return iv;
	}

Matrix3 CompMatrix(TimeValue t,INode *inode,ModContext *mc)
	{
	Interval iv;
	Matrix3 tm(1);	
	if (inode) 
		tm = tm * inode->GetObjTMBeforeWSM(t,&iv);
	return tm;
	}

#define NNUM_SEGS	16

void PaintMod::DrawCrossSectionMirror(Point3 a, Point3 align, Point3 alignDir, float length,float strenght, GraphicsWindow *gw)

	{


	Point3 plist[NNUM_SEGS+1];
	Point3 mka,mkb,mkc,mkd;

	align = Normalize(align);
	
	int ct = 0;
	float angle = TWOPI/float(NNUM_SEGS) ;
	Matrix3 rtm = RotAngleAxisMatrix(align, angle);
	Point3 p(0.0f,0.0f,0.0f);
	if (align.x == 1.0f)
		{
		p.z = length;
		}
	else if (align.y == 1.0f)
		{
		p.x = length;
		}
	else if (align.z == 1.0f)
		{
		p.y = length;
		}
	else if (align.x == -1.0f)
		{
		p.z = -length;
		}
	else if (align.y == -1.0f)
		{
		p.x = -length;
		}
	else if (align.z == -1.0f)
		{
		p.y = -length;
		}
	else 
		{
		p = Normalize(align^Point3(1.0f,0.0f,0.0f))*length;
		}

	for (int i=0; i<NNUM_SEGS; i++) {
		p = p * rtm;
		plist[ct++] = p;
		}

	p = p * rtm;
	plist[ct++] = p;


	for (i=0; i<NNUM_SEGS+1; i++) 
		{
		plist[i].x += a.x;
		plist[i].y += a.y;
		plist[i].z += a.z;
		}
	
	mka = plist[15];
	mkb = plist[3];
	mkc = plist[7];
	mkd = plist[11];

	if (drawRing)
		{
		gw->setColor(LINE_COLOR,ringColor);
		gw->polyline(NNUM_SEGS+1, plist, NULL, NULL, 0);

		plist[0] = mka;
		plist[1] = mkc;
		gw->polyline(2, plist, NULL, NULL, 0);

		plist[0] = mkb;
		plist[1] = mkd;
		gw->polyline(2, plist, NULL, NULL, 0);

		}

	plist[0] = a;
	plist[1] = a + (align * strength);

	if (drawNormal)
		{
		if (alignVec)
			{
			plist[1] = a + (alignDir * strength);
			}
		gw->setColor(LINE_COLOR,normalColor);
		gw->polyline(2, plist, NULL, NULL, 0);
		}

	plist[0] = a;
	float moveAmount = strength * fpressure;
	if (moveAmount < 0.1f) moveAmount = 0.1f;
	plist[1] = a + (align * moveAmount);

	Point3 center= plist[1];

	if (drawPressure)
		{
		gw->setColor(LINE_COLOR,pressureColor);
		gw->polyline(2, plist, NULL, NULL, 0);


		plist[0] = (mka-a) *.2f + center;
		gw->polyline(2, plist, NULL, NULL, 0);

		plist[0] = (mkb-a) *.2f + center;
		gw->polyline(2, plist, NULL, NULL, 0);

		plist[0] = (mkc-a) *.2f + center;
		gw->polyline(2, plist, NULL, NULL, 0);

		plist[0] = (mkd-a) *.2f + center;
		gw->polyline(2, plist, NULL, NULL, 0);


		}
	}

void PaintMod::DrawCrossSection(Point3 a, Point3 align, Point3 alignDir, float length,float strenght, GraphicsWindow *gw)

	{

	DrawCrossSectionMirror(a, align, alignDir, length,strenght, gw);

	if (useMirror)
		{
		int index1, index2,index3;
		if (mirrorDir == 0)
			{
			a.x = -a.x + offset;
			align.x = -align.x;
			index1 = 1;
			index2 = 2;
			index3 = 0;
			}
		else if (mirrorDir == 1)
			{
			a.y= -a.y + offset;
			align.y = -align.y;
			index1 = 0;
			index2 = 2;
			index3 = 1;

			}
		else if (mirrorDir == 2)
			{
			a.z = -a.z + offset;
			align.z = -align.z;
			index1 = 1;
			index2 = 0;
			index3 = 2;
			}

		DrawCrossSectionMirror(a, align,alignDir ,length,strenght, gw);

		gw->setColor(LINE_COLOR,GetUIColor(COLOR_SEL_GIZMOS));		
		Point3 plist[6];
		for (int i =0; i < 5; i++)
			{
			plist[i][index3] = 0.0f+(offset*0.5f);
			}
		float sz = mirrorDispSize;
		plist[0][index1] = -sz;
		plist[0][index2] = -sz;

		plist[1][index1] = sz;
		plist[1][index2] = -sz;

		plist[2][index1] = sz;
		plist[2][index2] = sz;

		plist[3][index1] = -sz;
		plist[3][index2] = sz;

		plist[4][index1] = -sz;
		plist[4][index2] = -sz;

		gw->polyline(5, plist, NULL, NULL, 0);
		}
	if (paintStroke)
		{
		for (int i = 1; i < strokeList.Count(); i++)
			{
			Point3 plist[3];
			plist[0] = strokeList[i-1];
			plist[1] = strokeList[i]; 
			gw->polyline(2, plist, NULL, NULL, 0);
			}
		}


}


void PaintMod::GetWorldBoundBox(
		TimeValue t,INode* inode, ViewExp *vpt, 
		Box3& box, ModContext *mc)
	{


	Interval iv;
	Matrix3 tm(1);	
	if (mc && mc->tm) tm = Inverse(*(mc->tm));
	if (inode) tm = tm * inode->GetObjTMBeforeWSM(t,&iv);
	

	PaintModData *pmd = (PaintModData *)mc->localData;

	if (pmd)
		{
		Point3 p = pmd->paintPoint;
		box.Init();
		box += p * tm;
		float s = strength;
		if (s < eradius) s = eradius;
		box.EnlargeBy(s);
		if (useMirror)
			{
			int index1, index2,index3;
			if (mirrorDir == 0)
				{
				index1 = 1;
				index2 = 2;
				index3 = 0;
				}
			else if (mirrorDir == 1)
				{
				index1 = 0;
				index2 = 2;
				index3 = 1;

				}
			else if (mirrorDir == 2)
				{
				index1 = 1;
				index2 = 0;
				index3 = 2;
				}
			Point3 plist[6];
			for (int i =0; i < 4; i++)
				{
				plist[i][index3] = 0.0f+(offset*0.5f);
				}
			float sz = mirrorDispSize;
			plist[0][index1] = -sz;
			plist[0][index2] = -sz;

			plist[1][index1] = sz;
			plist[1][index2] = -sz;

			plist[2][index1] = sz;
			plist[2][index2] = sz;

			plist[3][index1] = -sz;
			plist[3][index2] = sz;

			box += plist[0] * tm;
			box += plist[1] * tm;
			box += plist[2] * tm;
			box += plist[3] * tm;
		
			}	
		}

	}

int PaintMod::Display(
		TimeValue t, INode* inode, ViewExp *vpt, 
		int flagst, ModContext *mc)
	{
	GraphicsWindow *gw = vpt->getGW();
	Matrix3 tm = CompMatrix(t,inode,mc);
	int savedLimits;


	PaintModData *pmd = (PaintModData *)mc->localData;

	if ((pmd) && (pmd->draw))
		{
		gw->setRndLimits((savedLimits = gw->getRndLimits()) & ~GW_ILLUM);
		gw->setTransform(tm);
	
		if (inPaint)
			{		
			DrawCrossSection(pmd->paintPoint, pmd->paintNorm,pmd->alignDir, eradius, strength, gw); 
			}
		}


	gw->setRndLimits(savedLimits);
	return 0;

	}





RefTargetHandle PaintMod::GetReference(int i)
	{
	switch (i) {
		case PBLOCK_REF: return (RefTargetHandle)pblock;
		default: return NULL;
		}
	}

void PaintMod::SetReference(int i, RefTargetHandle rtarg)
	{
	switch (i) {
		case PBLOCK_REF: pblock = (IParamBlock2*)rtarg; break;
		}
	}



RefResult PaintMod::NotifyRefChanged(
		Interval changeInt,RefTargetHandle hTarget, 
		PartID& partID, RefMessage message)
	{
	switch (message) 
		{
		case REFMSG_CHANGE:
			if (hTarget == pblock)
				{
				ParamID changing_param = pblock->LastNotifyParamID();
				paint_param_blk.InvalidateUI(changing_param);
				}
				

			break;
		}
	return REF_SUCCEED;
	}




IOResult PaintMod::Load(ILoad *iload)
	{
//	Modifier::Load(iload);
	ULONG nb;
	IOResult res = IO_OK;


	
	DeltaListOld.ZeroCount();
	TempListOld.ZeroCount();
	SelectVertListOld.ZeroCount();
	

	
	Point3 zp(0.0f,0.0f,0.0f);
	Tab<BOOL> bSelectVertList;
	BOOL oldSelection = FALSE;

	while (IO_OK==(res=iload->OpenChunk())) {
		switch (iload->CurChunkID()) {
			case POINTS_CHUNK: {
				Point3 p;
				res = iload->Read(&p,sizeof(p),&nb);
				DeltaListOld.Append(1,&p,1);
				TempListOld.Append(1,&zp,1);
				break;
				}
			case SELECT_VERTS_CHUNK: {
				BOOL b;
				res = iload->Read(&b,sizeof(b),&nb);
				bSelectVertList.Append(1,&b,1);
				oldSelection = TRUE;
				break;
				}
			case SELECT_VERTSFLOAT_CHUNK: {
				float f;
				res = iload->Read(&f,sizeof(f),&nb);
				SelectVertListOld.Append(1,&f,1);
				break;
				}

			case INK_TYPE_CHUNK: {
				int ink;
				res = iload->Read(&ink,sizeof(ink),&nb);
				inkType = ink;
				break;
				}
			case BRUSH_CHUNK:
				{
				BrushClass *t = new BrushClass();
				res = t->Load(iload);
				brushList.Append(1,&t);
				}
			}
		iload->CloseChunk();
		if (res!=IO_OK)  return res;
		}	

	if (oldSelection)
		{
		SelectVertListOld.SetCount(bSelectVertList.Count());
		for (int i =0; i < bSelectVertList.Count(); i++)
			{
			if (bSelectVertList[i])
				SelectVertListOld[i] = 1.0f;
			else SelectVertListOld[i] = 0.0f;
			}
		}

	ParamBlock2PLCB* plcb = new ParamBlock2PLCB(versions, NUM_OLDVERSIONS, &paint_param_blk, this, PBLOCK_REF);
	iload->RegisterPostLoadCallback(plcb);
	return IO_OK;
	}

IOResult PaintMod::Save(ISave *isave)
	{

	Modifier::Save(isave);

	for (int i = 0 ; i < brushList.Count(); i++)
		{
		brushList[i]->Save(isave);
		}
	

	return IO_OK;
	}



IOResult PaintMod::SaveLocalData(ISave *isave, LocalModData *pld)
{
	PaintModData *pmd;

	pmd = (PaintModData*)pld;
	

	return pmd->Save(isave);

}


IOResult PaintMod::LoadLocalData(ILoad *iload, LocalModData **pld)
{
	PaintModData *pmd= new PaintModData();
	*pld = pmd;
	return pmd->Load(iload);
	
}

Point3 PaintDeformer::Map(int i, Point3 p)
	{
	if (i < mod->DeltaListOld.Count())
		{
		p += (mod->DeltaListOld[i] + mod->TempListOld[i]) * mod->effect;
		}
	if (i < pmd->DeltaList.Count())
		{
		p += (pmd->DeltaList[i] + pmd->TempList[i]) * mod->effect;
		}

	return p;
	}



int MyEnumProc::proc(ReferenceMaker *rmaker) 
	{ 
	if (rmaker->SuperClassID()==BASENODE_CLASS_ID)    
		{
		Nodes.Append(1, (INode **)&rmaker);  
		}


	return 0;
	}	



void PaintMod::LoadWinTabDLL()
	{
	hWinTabDLL = NULL;
	hWinTabDLL = LoadLibrary("WINTAB32");
	if (hWinTabDLL)
		{
		PaintWTPacket = (WTPACKET)GetProcAddress(hWinTabDLL,"WTPacket");
		PaintWTOpen = (WTOPEN)GetProcAddress(hWinTabDLL,"WTOpenA");
		PaintWTInfo = (WTINFO)GetProcAddress(hWinTabDLL,"WTInfoA");
   		}
	}

void PaintMod::UnLoadWinTabDLL()
	{
	if (hWinTabDLL)
		FreeLibrary(hWinTabDLL);       
	hWinTabDLL = NULL;
	PaintWTPacket = NULL;
	PaintWTOpen = NULL;
	PaintWTInfo = NULL;
	}


void PaintMod::FilloutBrushList()
	{
	HWND brushHWND = GetDlgItem(hWnd, IDC_BRUSHLIST);
	int currentPos = SendMessage( brushHWND, CB_GETCURSEL, 0 , 0 );

	SendMessage(brushHWND, CB_RESETCONTENT, 0, 0);

	for (int i= 0; i < brushList.Count(); i++)
		{
//fillout combo box
		SendMessage(brushHWND, CB_ADDSTRING, 0, (LPARAM)brushList[i]->name.data());
		}
	SendMessage( brushHWND, CB_SETCURSEL, (WPARAM) currentPos , 0 );

	}

void PaintMod::AddBrush(TSTR &name)
	{
	float st,r;
	Interval valid;

	pblock->GetValue(paint_str,0,st,valid);		
	pblock->GetValue(paint_eradius,0,r,valid);		
	
	BrushClass *temp = new BrushClass();
	temp->name = name;
	temp->radius = r;
	temp->str = st;
	temp->inkType = inkType;

	if (inkType > (NUMBER_DEFAULTINKS-1))
		{
		int ink = inkType-NUMBER_DEFAULTINKS;
		ReferenceTarget *ref;
		pblock->GetValue(paint_custominks,0,ref,FOREVER,ink);
		temp->brushID = ref->ClassID();
		}


	SendMessage( inkHWND, CB_SETCURSEL, (WPARAM) inkType , 0 );

	ReferenceTarget *ref;

	pblock->GetValue(paint_falloffcurve,0,ref, FOREVER);
	curveCtl = (ICurveCtl *) ref;

	ICurve *pCurve = NULL;
	
	pCurve = curveCtl->GetControlCurve(0);

	CurvePoint pt;

	for (int i =0; i < pCurve->GetNumPts(); i++)
		{
		pt = pCurve->GetPoint(0,i);
		temp->points.Append(1,&pt);
		}

	brushList.Append(1,&temp);
	
	FilloutBrushList();
	}

void PaintMod::AddBrush()
	{
	int OK = DialogBoxParam  (hInstance, MAKEINTRESOURCE(IDD_ADDBRUSHDIALOG),
			hWnd, AddBrushDlgProc, (LPARAM)this);
	}

void PaintMod::RemoveBrush()
	{
	HWND brushHWND = GetDlgItem(hWnd, IDC_BRUSHLIST);
	int currentPos = SendMessage( brushHWND, CB_GETCURSEL, 0 , 0 );
	if (currentPos >=0)
		{
		SendMessage( brushHWND, CB_DELETESTRING, (WPARAM)currentPos , 0 );
		BrushClass *temp = brushList[currentPos];
		brushList.Delete(currentPos,1);
		delete temp;
		}
	FilloutBrushList();
	}
void PaintMod::SetBrush()
	{
	HWND brushHWND = GetDlgItem(hWnd, IDC_BRUSHLIST);
	int currentPos = SendMessage( brushHWND, CB_GETCURSEL, 0 , 0 );

	macroRecorder->FunctionCall(_T("$.modifiers[#Paint_Modifier].setBrushByIndex"), 1, 0,mr_int,(currentPos+1));

	SetBrush(currentPos);
/*
	float st,r;
	Interval valid;
	int ink;

	st = brushList[currentPos]->str;
	r =  brushList[currentPos]->radius;
	ink = brushList[currentPos]->inkType;
	pblock->SetValue(paint_str,0,st);		
	pblock->SetValue(paint_eradius,0,r);

	pblock->SetValue(paint_inktype,0,ink);


	ReferenceTarget *ref;

	pblock->GetValue(paint_falloffcurve,0,ref, FOREVER);
	curveCtl = (ICurveCtl *) ref;

	ICurve *pCurve = NULL;
	
	pCurve = curveCtl->GetControlCurve(0);

	
	pCurve->SetNumPts(brushList[currentPos]->points.Count());

	for (int i =0; i < brushList[currentPos]->points.Count(); i++)
		{
		CurvePoint pt;
		pt = brushList[currentPos]->points[i];
		pCurve->SetPoint(0,i,&pt);
		}
	curveCtl->Redraw();
	SendMessage( inkHWND, CB_SETCURSEL, (WPARAM)ink , 0 );
	*/
	}

void PaintMod::SetBrush(int index)
	{

	if (inkType >(NUMBER_DEFAULTINKS-1))
		{
		int cInk = inkType -NUMBER_DEFAULTINKS;
		Interval iv;
		ReferenceTarget *ref;
		pblock->GetValue(paint_custominks,0,ref,iv,cInk);
		IInkClass *customInk = (IInkClass*) ref;
		if ((customInk) && (ip))customInk->EndEditParams(ip, END_EDIT_REMOVEUI,NULL);
		}


	HWND brushHWND = GetDlgItem(hWnd, IDC_BRUSHLIST);
	int currentPos = index;

	if ((currentPos <0) || (currentPos >= brushList.Count()))
		return;

	float st,r;
	Interval valid;
	int ink;

	st = brushList[currentPos]->str;
	r =  brushList[currentPos]->radius;
	ink = brushList[currentPos]->inkType;
	pblock->SetValue(paint_str,0,st);		
	pblock->SetValue(paint_eradius,0,r);

	if (ink < NUMBER_DEFAULTINKS)
		pblock->SetValue(paint_inktype,0,ink);
	else
		{
		for (int i =0; i < pblock->Count(paint_custominks);i++)
			{
			ReferenceTarget *ref;
			pblock->GetValue(paint_custominks,0,ref,FOREVER,i);
			IInkClass *inkRef = (IInkClass*) ref;
			if (inkRef->ClassID() == brushList[currentPos]->brushID)
				{
				ink = NUMBER_DEFAULTINKS+i;
				i = pblock->Count(paint_custominks);
				}
			}
		pblock->SetValue(paint_inktype,0,ink);
		}


	ReferenceTarget *ref;

	pblock->GetValue(paint_falloffcurve,0,ref, FOREVER);
	curveCtl = (ICurveCtl *) ref;

	ICurve *pCurve = NULL;
	
	pCurve = curveCtl->GetControlCurve(0);

	
	pCurve->SetNumPts(brushList[currentPos]->points.Count());

	for (int i =0; i < brushList[currentPos]->points.Count(); i++)
		{
		CurvePoint pt;
		pt = brushList[currentPos]->points[i];
		pCurve->SetPoint(0,i,&pt);
		}
	curveCtl->Redraw();
	SendMessage( inkHWND, CB_SETCURSEL, (WPARAM)ink , 0 );
	SendMessage( brushHWND, CB_SETCURSEL, (WPARAM)currentPos , 0 );
	inkType = ink;


	if (inkType >(NUMBER_DEFAULTINKS-1))
		{
		int cInk = inkType -NUMBER_DEFAULTINKS;
		Interval iv;
		ReferenceTarget *ref;
		pblock->GetValue(paint_custominks,0,ref,iv,cInk);
		IInkClass *customInk = (IInkClass*) ref;
		if (customInk) 
			{
			currentInk = customInk;
			if (ip) customInk->BeginEditParams(ip, customInkFlags,NULL);
			}
		}

	}



INT_PTR CALLBACK AddBrushDlgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam) 
	{
	static PaintMod *mod ;


	switch (msg) 
		{
	case WM_INITDIALOG:
		{
		mod = (PaintMod*)lParam;

		ICustEdit *iName = GetICustEdit(GetDlgItem(hWnd,IDC_EDIT));
		TSTR name;

		if (mod->inkType == 0)
			name.printf("Normal(%3.1f , %3.1f)",mod->strength,mod->eradius);
		else if (mod->inkType == 1)
			name.printf("OrgNormal(%3.1f , %3.1f)",mod->strength,mod->eradius);
		else if (mod->inkType == 2)
			name.printf("Scale(%3.1f , %3.1f)",mod->strength,mod->eradius);
		else if (mod->inkType == 3)
			name.printf("Smooth(%3.1f , %3.1f)",mod->strength,mod->eradius);
		else if (mod->inkType == 4)
			name.printf("MoveZ(%3.1f , %3.1f)",mod->strength,mod->eradius);
		else if (mod->inkType == 5)
			name.printf("MoveXY(%3.1f , %3.1f)",mod->strength,mod->eradius);
		else if (mod->inkType == 6)
			name.printf("MoveZScreen(%3.1f , %3.1f)",mod->strength,mod->eradius);
		else if (mod->inkType == 7)
			name.printf("MoveXYScreen(%3.1f , %3.1f)",mod->strength,mod->eradius);
		else if (mod->inkType == 8)
			name.printf("SelVert(%3.1f , %3.1f)",mod->strength,mod->eradius);
		else if (mod->inkType == 9)
			name.printf("SelFace(%3.1f , %3.1f)",mod->strength,mod->eradius);
		else
			{
			int cInk = mod->inkType -NUMBER_DEFAULTINKS;
			Interval iv;
			ReferenceTarget *ref;
			mod->pblock->GetValue(paint_custominks,0,ref,iv,cInk);
			IInkClass *customInk = (IInkClass*) ref;
			TSTR n;
			customInk->GetClassName(n);
			
			name.printf("%s(%3.1f , %3.1f)",n,mod->strength,mod->eradius);
			}

//		name.printf("Brush(%3.1f,%3.1f)",mod->strength,mod->eradius);
		iName->SetText( name);
		ReleaseICustEdit(iName);

		CenterWindow(hWnd,GetParent(hWnd));
		break;
		}
		


	case WM_COMMAND:
		switch (LOWORD(wParam)) 
			{
			case IDOK:
				{
				ICustEdit *iName = GetICustEdit(GetDlgItem(hWnd,IDC_EDIT));
				TSTR name;



				TCHAR tname[200];
				iName->GetText(tname,200);
				ReleaseICustEdit(iName);
				name.printf("%s",tname);
				mod->AddBrush(name);
				EndDialog(hWnd,1);
				break;
				}
			case IDCANCEL:
				EndDialog(hWnd,0);
				break;
			}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}



void PaintMod::SetCustomInk()
{
//clear all the current custom ink
//	pblock->ZeroCount(paint_custominks);

	Tab<ReferenceTarget *> refList;
//loop through the dll list looking for any that are iink types
	SubClassList *scList = GetCOREInterface()->GetDllDir().ClassDir().GetClassList(REF_TARGET_CLASS_ID);
	int cursel = -1;
	for ( long i = 0; i < scList->Count(ACC_ALL); ++i) 
		{
		ClassDesc* pClassD = (*scList)[ i ].CD();

		const TCHAR *cat = pClassD->Category();
		TCHAR *defcat = GetString(IDS_PW_GIZMOCATEGORY);
				

		if ((cat) && (_tcscmp(cat,defcat) == 0)) 
			{
			int iret = SendMessage(inkHWND, CB_ADDSTRING, 0L, (LPARAM)(pClassD->ClassName()) );
			Class_ID cid = pClassD->ClassID();
			IInkClass *customInk;

			customInk = (IInkClass *) CreateInstance(REF_TARGET_CLASS_ID,cid);
//add it to the param block
			ReferenceTarget *ref = (ReferenceTarget *) customInk;

			if (ref->GetInterface(I_INK))
				{
				refList.Append(1,&ref);
//				pblock->Append(paint_custominks,1,&ref);
				}
			else ref->DeleteThis();

//add them to the list

			}

		}
	for (i =0; i < refList.Count(); i++)
		{
		for (int j=0; j< pblock->Count(paint_custominks); j++)
			{	
			ReferenceTarget *refInk;
			pblock->GetValue(paint_custominks,0,refInk,FOREVER,j);
			if ((refInk->ClassID() == refList[i]->ClassID()))
				{
				refList[i]->DeleteThis();
				refList[i] = NULL;
				j = pblock->Count(paint_custominks); 
				}
			}
		}
	for (i =0; i < refList.Count(); i++)
		{
		if (refList[i] != NULL)
			{
			pblock->Append(paint_custominks,1,&refList[i]);
			}
		}


}
