
#include "mods.h"







void	PaintMod::fnButtonPaint()
	{
	if (ip)
		{
		if (ip->GetCommandMode()->ID()==CID_PAINT) 
			{
			ip->SetStdCommandMode(CID_OBJMOVE);
			} 
		else 
			{
			ip->SetCommandMode(paintMode);
			}
		}
	}
void	PaintMod::fnButtonResetGraph()
	{
	ResetGraph();
	}
void	PaintMod::fnButtonAddBrush()
	{
	}
void	PaintMod::fnButtonRemoveBrush()
	{
	RemoveBrush();
	}
void	PaintMod::fnButtonReset()
	{
	ResetVerts();
	
	}


void	PaintMod::fnSetBrushByIndex(int index)
	{
	index--;
	SetBrush(index);
	}
void	PaintMod::fnSetBrushByName(TCHAR *name)
	{
	
	TSTR n(name);
	for (int i = 0; i < brushList.Count(); i++)
		{
		if (_tcscmp(n,brushList[i]->name)==0)
			{
			SetBrush(i);
			i = brushList.Count();
			}
		}
	}

int		PaintMod::fnCreateBrush(TCHAR *name)

	{
	BrushClass *t = new BrushClass();
	t->name.printf("%s",name);
	t->inkType = inkType;
	t->str = strength;
	t->radius = eradius;
	t->points.SetCount(2);

	CurvePoint pt;

	pt.flags = CURVEP_CORNER | CURVEP_BEZIER | CURVEP_ENDPOINT;
	pt.out.x = 0.33f;
	pt.out.y = 0.0f;
	pt.in.x = -0.33f;
	pt.in.y = 0.0f;

	pt.p.x = 0.0f;			
	pt.p.y = 1.0f;	

	t->points[0] = pt;

	pt.p.x = 1.0f;			
	pt.p.y = 0.0f;			
	pt.in.x = -.33f;
	pt.in.y = 0.0f;
	pt.out.x = .33f;
	pt.out.y = 0.0f;

	t->points[1] = pt;

	brushList.Append(1,&t);

	FilloutBrushList();

	return brushList.Count();

	}

int		PaintMod::fnNumberBrushes()
	{
	return brushList.Count();
	}

void	PaintMod::fnSetBrushDataGraph(int index, Point2 p1, Point2 handle1, Point2 p2, Point2 handle2)
	{
	index--;
	if ((index < 0) || (index >= brushList.Count())) return;

	brushList[index]->points[0].p = p1;
	brushList[index]->points[1].p = p2;

	brushList[index]->points[0].out = handle1;
	brushList[index]->points[1].in = handle2;

	}

void	PaintMod::fnSetBrushDataName(int index, TCHAR *name)
	{
	index--;
	if ((index < 0) || (index >= brushList.Count())) return;
	brushList[index]->name.printf(name);
	FilloutBrushList();
	}

void	PaintMod::fnSetBrushDataStrength(int index, float str)
	{
	index--;
	if ((index < 0) || (index >= brushList.Count())) return;
	brushList[index]->str = str;

	}
void	PaintMod::fnSetBrushDataRadius(int index, float r)
	{
	index--;
	if ((index < 0) || (index >= brushList.Count())) return;
	brushList[index]->radius = r;

	}
void	PaintMod::fnSetBrushDataInk(int index, int ink)
	{
	index--;
	if ((index < 0) || (index >= brushList.Count())) return;
	brushList[index]->inkType = ink;

	}

TCHAR*	PaintMod::fnGetBrushDataName(int index)
	{
	index--;
	if ((index < 0) || (index >= brushList.Count())) return NULL;
	TCHAR *name = brushList[index]->name.data();
	return name;

	}

float	PaintMod::fnGetBrushDataStrength(int index)
	{
	index--;
	if ((index < 0) || (index >= brushList.Count())) return 0.0f;
	return  brushList[index]->str;
	}

float	PaintMod::fnGetBrushDataRadius(int index)
	{
	index--;
	if ((index < 0) || (index >= brushList.Count())) return 0.0f;
	return  brushList[index]->radius;
	}

int		PaintMod::fnGetBrushDataInk(int index)
	{
	index--;
	if ((index < 0) || (index >= brushList.Count())) return 0;
	return  (brushList[index]->inkType);
	}


void	PaintMod::fnRemoveBrush(int index)
	{
	index--;
	if ((index < 0) || (index >= brushList.Count())) return;
	brushList.Delete(index,1);
	FilloutBrushList();
	}