
#include "mods.h"


void PaintModData::BuildNormals(Mesh *mesh)
{

	Face *face;	
	Point3 *verts;
	Point3 v0, v1, v2;


	face = mesh->faces;	
	verts = mesh->verts;
	vnorms.SetCount(mesh->getNumVerts());
	fnorms.SetCount(mesh->getNumFaces());

	// Compute face and vertex surface normals
//build smoothing amount
	smoothAmount.SetCount(mesh->getNumVerts());
	Tab<int> smoothCount;
	smoothCount.SetCount(mesh->getNumVerts());

	for (int i = 0; i < mesh->getNumVerts(); i++) 
		{
		vnorms[i] = VNormal();
		smoothAmount[i] = 0.0f;
		smoothCount[i] = 0.0f;
		}
	for (i = 0; i < mesh->getNumFaces(); i++, face++) 
		{

// Calculate the surface normal
		v0 = verts[face->v[0]];
		v1 = verts[face->v[1]];
		v2 = verts[face->v[2]];
		fnorms[i] = (v1-v0)^(v2-v1);
		for (int j=0; j<3; j++) 
			{		
			vnorms[face->v[j]].AddNormal(fnorms[i],face->smGroup);
			}
		fnorms[i] = Normalize(fnorms[i]);
		}
	for (i=0; i < mesh->getNumVerts(); i++) 
		{
		vnorms[i].Normalize();
		}
	for (i = 0; i < mesh->getNumFaces(); i++, face++) 
		{
//get face norm
		Point3 fn = fnorms[i];
		for (int j=0; j<3; j++) 
			{		
//get the vertex norm
			Point3 vn;
//..			vn = 
//get the dot
			
			}
		}

	for (i=0; i < mesh->getNumVerts(); i++) 
		{
		}

}


void PaintModData::BuildONormals(Mesh *mesh)
{

//	rebuildOriginalNorms = FALSE;
	Face *face;	
	Point3 *verts;
	Point3 v0, v1, v2;


	face = mesh->faces;	
	verts = mesh->verts;
	origVNorms.SetCount(mesh->getNumVerts());
	origFNorms.SetCount(mesh->getNumFaces());

	// Compute face and vertex surface normals
	for (int i = 0; i < mesh->getNumVerts(); i++) 
		{
		origVNorms[i] = VNormal();
		}
	for (i = 0; i < mesh->getNumFaces(); i++, face++) 
		{

// Calculate the surface normal
		v0 = verts[face->v[0]];
		v1 = verts[face->v[1]];
		v2 = verts[face->v[2]];
		origFNorms[i] = (v1-v0)^(v2-v1);
		for (int j=0; j<3; j++) 
			{		
			origVNorms[face->v[j]].AddNormal(origFNorms[i],0xffff);
			}
		origFNorms[i] = Normalize(origFNorms[i]);
		}
	for (i=0; i < mesh->getNumVerts(); i++) 
		{
		origVNorms[i].Normalize();
		}
}


IOResult PaintModData::Load(ILoad *iload)
{

//	Modifier::Load(iload);
	ULONG nb;
	IOResult res = IO_OK;


	
	DeltaList.ZeroCount();
	TempList.ZeroCount();
	SelectVertList.ZeroCount();
	

	Point3 p,zp(0.0f,0.0f,0.0f);

	while (IO_OK==(res=iload->OpenChunk())) {
		switch (iload->CurChunkID()) {
			case LPOINTS_CHUNK: {
				Point3 p;
				res = iload->Read(&p,sizeof(p),&nb);
				DeltaList.Append(1,&p,1);
				TempList.Append(1,&zp,1);
				break;
				}
			case LSELECT_VERTSFLOAT_CHUNK: {
				float f;
				res = iload->Read(&f,sizeof(f),&nb);
				SelectVertList.Append(1,&f,1);
				break;
				}
			case LSELECT_FACES_CHUNK: {
				selectedFaceList.Load(iload);
				break;
				}

			}
		iload->CloseChunk();
		if (res!=IO_OK)  return res;
		}	

	return IO_OK;

}

IOResult PaintModData::Save(ISave *isave)
{

	ULONG nb;

		
	for (int i = 0; i< DeltaList.Count(); i++)
		{
		Point3 p;
		p = DeltaList[i];
		isave->BeginChunk(LPOINTS_CHUNK);
		isave->Write(&p,sizeof(p),&nb);
		isave->EndChunk();	
		}

	for (i = 0; i< SelectVertList.Count(); i++)
		{
		float b;
		b = SelectVertList[i];
		isave->BeginChunk(LSELECT_VERTSFLOAT_CHUNK);
		isave->Write(&b,sizeof(b),&nb);
		isave->EndChunk();	
		}

	isave->BeginChunk(LSELECT_FACES_CHUNK);
	selectedFaceList.Save(isave);
	isave->EndChunk();	

return IO_OK;
}
